package com.baojia.mebike.feature.exclusive.detail
import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.amap.api.mapcore.util.it
import com.baojia.mebike.feature.exclusive.detail.ExchangeDetailAdapter
import com.baojia.mebike.R
import com.baojia.mebike.R.id.recyclerview
import com.baojia.mebike.R.id.refreshLayout
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.feature.exclusive.detail.ExchangeDetailResponse
import com.scwang.smartrefresh.layout.api.RefreshLayout
import com.scwang.smartrefresh.layout.listener.OnRefreshListener
import kotlinx.android.synthetic.main.layout_recyclerview_only.*

class ExchangeDetailActivity : BaseActivity(),OnRefreshListener{
    companion object {
        @JvmStatic
        fun start(activity : Activity,type :Int){
            val intent = Intent()
            intent.setClass(activity, ExchangeDetailActivity::class.java)
            intent.putExtra("type",type)
            activity.startActivity(intent)
        }
    }
    override fun layoutId(): Int = R.layout.layout_recyclerview_only

    override fun isVisibleTitleBar(): Boolean = true

    //0 免费换电  1 紧急换电
    private var type  = 0

    override fun setTitle(): String {
        if (type == 0)
           return "免费换电"
        else
           return "紧急换电"
    }
    private val mData = ArrayList<ExchangeDetailResponse>()

    private val adapter = ExchangeDetailAdapter(this, mData, R.layout.item_exchange_detail)

    override fun bindView(savedInstanceState: Bundle?) {
        refreshLayout.isEnableRefresh = false
        refreshLayout.isEnableLoadmore = false

        recyclerview.layoutManager = LinearLayoutManager(this)
        recyclerview.adapter = adapter;
    }

    override fun initData() {
        super.initData()
        intent?.let {
            type = it.getIntExtra("type",0)
        }
    }


    override fun onRefresh(refreshlayout: RefreshLayout?) {

    }

}