package com.baojia.mebike.feature.exclusive.iWillExchange

import android.app.Activity
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.exclusive.IWillExchangeResponse
import com.baojia.mebike.data.response.exclusive.SubmitChangeBatteryResponse
import com.baojia.mebike.feature.model.PayModel
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable

class IwillExchangeModel(activity: Activity) : PayModel(activity) {
    private val URL_IWILL_EXCHANGE = "/bike/knight/change/list"
    // 免费换电下单
    private val SUBMIT_CHANGE_BATTERY_ORDER = "/bike/knight/generate/free/changeOrder"

    fun submitChangeBatteryOrder(bikeId: Int, httpCallback: HttpCallback<SubmitChangeBatteryResponse.DataBean>?): Disposable {
        val params = mutableMapOf<String, Any>()
        params["bikeId"] = bikeId
        return HttpUtils.postRequest(activity, SUBMIT_CHANGE_BATTERY_ORDER, params, object : HttpCallback<SubmitChangeBatteryResponse>() {
            override fun onSucceed(data: SubmitChangeBatteryResponse?) {
                super.onSucceed(data)
                if (data?.data != null) {
                    httpCallback?.onSucceed(data.data)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(activity, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }, SubmitChangeBatteryResponse::class.java)
    }

    fun getData(bikeId: Int, httpCallback: HttpCallback<IWillExchangeResponse.DataBean>?): Disposable {

        val params = mapOf<String, Any>("bikeId" to bikeId)

        return HttpUtils.postRequest(activity, URL_IWILL_EXCHANGE, params,
                object : HttpCallback<IWillExchangeResponse>() {

                    override fun onSucceed(data: IWillExchangeResponse?) {
                        super.onSucceed(data)

                        data?.data?.let {
                            httpCallback?.onSucceed(it)
                        }

                    }

                    override fun onFailed(code: Int, message: String?) {
                        super.onFailed(code, message)
                        Toast.show(activity, message)
                    }

                    override fun onError(code: Int, message: String?) {
                        super.onError(code, message)
                        onFailed(code, message)
                    }
                }, IWillExchangeResponse::class.java)
    }

}