package com.baojia.mebike.feature.exclusive.nearBike

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.MarkerBean
import com.baojia.mebike.data.response.bike.BikeDetailsResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/22:5:39 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
interface NearBikeContract {

    interface View : IBaseView<Presenter> {

        fun drawBikeMarker(markerItemList: ArrayList<MarkerBean>)
        /**
         * 选中的车辆id
         */
        fun bikeId(): Int

        fun setAppointmentData(shutdownTime: Int, bikeId: Int)
        /**
         * 判断是否有marker
         */
        fun isHaveBikeMarker(shutdownTime: Int, bikeId: Int)

        /**
         * 取消预约
         */
        fun cancelAppointmentSucceed()

        /**
         * 显示车辆详情loading
         */
        fun showLoadingDialog()

        /**
         * 隐藏车辆详情loading
         */
        fun dismissLoadingDialog()

        /**
         * 设置车辆详情数据
         */
        fun setBikeDetails(data: BikeDetailsResponse.DataBean?)

        fun setAppointmentMarker(shutdownTime: Int,markerBean: MarkerBean?,bikeDetailsData:BikeDetailsResponse.DataBean?)
    }

    interface Presenter : IBasePresenter {

        fun searchBike()
        /**
         * 查看订单
         */
        fun getProcessingOrder()

        /**
         * 预约
         */
        fun appointment()

        /**
         * 取消预约
         */
        fun cancelAppointment()

        /**
         * 鸣笛
         */
        fun findBikeAndWhistle()

        /**
         * 获取车辆详情
         */
        fun getBikeDetails(reserveType:Int = 0)

        fun isAppointment(): Boolean
    }
}