package com.baojia.mebike.feature.exclusive.powerStation

import android.app.Activity
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.CommData
import com.baojia.mebike.data.response.exclusive.PowerStationResponse
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.CollectionsWrapper
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/22:6:51 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class PowerStationModel constructor(mContext: Activity) : BaseModel(mContext) {

    private val POWER_STATION_URL = "/bike/knight/search/battery/replace/site"

    fun powerStation(bikeId: Int, httpCallback: HttpCallback<ArrayList<PowerStationResponse.DataBean.BatteryReplaceSiteVoListBean>>): Disposable {
        var params = mutableMapOf<String, Any?>()
        params["latitude"] = CommData.locationConfig.latLng.latitude
        params["longitude"] = CommData.locationConfig.latLng.longitude
        params["bikeId"] = bikeId
        return HttpUtils.postRequest(activity, POWER_STATION_URL, params, object : HttpCallback<PowerStationResponse>() {
            override fun onSucceed(data: PowerStationResponse?) {
                super.onSucceed(data)

                if (data?.data == null || CollectionsWrapper.isEmpty(data?.data.batteryReplaceSiteVoList)) {
                    Toast.show(activity, R.string.no_battery_sit)
                    return
                }

                data?.data?.let {
                    if (it.batteryReplaceSiteVoList != null) {
                        httpCallback.onSucceed(it.batteryReplaceSiteVoList)
                    }
                }

            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(activity, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }, PowerStationResponse::class.java)
    }
}