package com.baojia.mebike.feature.exclusive.shopping.aboutbikeconfig

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.shopping.BikeConfigBean
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.AboutBikeConfigContract
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.AboutBikeConfigPresenter
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikeConfigActivity
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.ToolBox
import kotlinx.android.synthetic.main.activity_about_bike_config.*
import kotlinx.android.synthetic.main.layout_buy_bike_info2.*
import kotlinx.android.synthetic.main.layout_list_nodata.*

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.aboutbikeconfig
 * @author lycc1
 * @time 2018/12/24 22:51
 * @class describe
 * @class 中文描述
 */
class AboutBikeConfigAct : BaseActivity(), AboutBikeConfigContract.View {

    var maxPower = ""
    var maxSpeed = ""
    var bikeImgUrl = ""
    var bikeTitle = ""

    override fun setListData(data: BikeConfigBean?) {
        if (data?.data == null){
            bikeConfigLayout.visibility = View.GONE
            llNodata.visibility = View.VISIBLE
        }
        data?.data?.let {
            it.pmallProductBo?.let {
                bikeConfigLayout.visibility = if (it == null) View.GONE else View.VISIBLE
                bikeTitleName.text = it.name ?: ""
                buyBikeInfoLeftContentTv.text = it.maxSpeed.toString() + "KM/小时"
                buyBikeInfoRightContentTv.text = it.maxPower.toString() + "Km"
                ImageLoader.loadUrl(bugBikePicImageView, it.imgUrl ?: "")
                bikeImgUrl = it.imgUrl.toString()
                maxSpeed = it.maxSpeed.toString() + "km/小时"
                maxPower = it.maxPower.toString() + "km"
                bikeTitle =it.name.toString()
            }

            it.pmallGoodsBoList?.let {
                if (it.isEmpty()) {
                    recyclerView.visibility = View.GONE
                    llNodata.visibility = View.VISIBLE
                    return
                }
                mDatas.clear()
                mDatas.addAll(it)
                mAdapter?.notifyDataSetChanged()
            }
        }

    }


    var mPresenter: AboutBikeConfigContract.Presenter? = null
    var mAdapter: AboutBikeConfigAdapter? = null
    private val mDatas = ArrayList<BikeConfigBean.DataBean.PmallGoodsBoListBean>()
    var productId: String? = null

    companion object {
        fun openActivity(context: Context, productID: String) {
            var intent = Intent(context, AboutBikeConfigAct::class.java)
            intent.putExtra("productId", productID)
            context.startActivity(intent)
        }
    }

    override fun isVisibleTitleBar() = true


    override fun setPresenter(presenter: AboutBikeConfigContract.Presenter?) {

    }

    override fun layoutId(): Int {
        return R.layout.activity_about_bike_config
    }

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            productId = it.getStringExtra("productId")
        }
        mPresenter = AboutBikeConfigPresenter(this, this)

        initRecyclerView()

        mPresenter?.getListConfig(productId);

        mAdapter?.setOnItemChildViewClickListner { _, position ->
            run {
                var item   = mDatas[position]
                item?:return@run
                BuyBikeConfigActivity.start(this,0,bikeTitle,maxPower,maxSpeed,bikeImgUrl,item.goodsType,item.productId,item.goodsId,"")
            }
        }
    }

    private fun initRecyclerView() {
        mAdapter = AboutBikeConfigAdapter(this, mDatas, R.layout.adapter_about_config)

//
        recyclerView.layoutManager = LinearLayoutManager(this)
        recyclerView.adapter = mAdapter

    }
}