package com.baojia.mebike.feature.exclusive.shopping.aboutbikeconfig

import android.content.Context
import android.graphics.Color
import android.text.SpannableString
import android.text.Spanned
import android.text.style.ForegroundColorSpan
import android.widget.TextView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.shopping.BikeConfigBean
import com.baojia.mebike.widget.CommonWebViewActivity
import java.lang.StringBuilder

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.bill
 * @author lycc1
 * @time 2018/12/25 15:03
 * @class describe
 * @class 中文描述
 */
class AboutBikeConfigAdapter(val context: Context, list: ArrayList<BikeConfigBean.DataBean.PmallGoodsBoListBean>, layoutId: Int)
    : BaseCommonAdapter<BikeConfigBean.DataBean.PmallGoodsBoListBean>(context, list, layoutId) {
    override fun convert(holder: BaseViewHolder?, list: MutableList<BikeConfigBean.DataBean.PmallGoodsBoListBean>?, position: Int) {
        val bean = list?.get(position) ?: return
        var configText = holder?.findView<TextView>(R.id.priceConfigOption1)
        stringSpanText(configText, bean?.desc ?: return)

        holder?.setText(R.id.priceConfigPrice, "￥" + bean.showPrice)
        holder?.setText(R.id.priceConfigTitle, bean.goodsName)
        holder?.setVisbility(R.id.priceConfigSale, bean.discountType == 1)

        holder?.addOnClickListener(this, R.id.joinBuySuccessOkTv, position)
    }

    fun stringSpanText(text: TextView?, desc: MutableList<BikeConfigBean.DataBean.PmallGoodsBoListBean.DescBean>) {
        if (desc.isEmpty()) {
            return
        }
        for (it in desc) {
            if (it?.desc == null || it.desc.isEmpty()) {
                continue
            }
            var spannableString = SpannableString(it.desc)
            spannableString.setSpan(
                    ForegroundColorSpan(context.resources.getColor(if (it.color == 1) R.color.focus_text_color else R.color.text_third_color)),
                    0,
                    spannableString.length,
                    Spanned.SPAN_INCLUSIVE_EXCLUSIVE
            )
            text?.append("• ")
            text?.append(spannableString)
            if (it != desc[desc.size - 1]) {
                text?.append("\n")
            }

        }
    }
}