package com.baojia.mebike.feature.exclusive.shopping.aboutexclusive

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.shopping.BannerData
import com.baojia.mebike.data.response.shopping.ListProductBean
import com.baojia.mebike.feature.exclusive.shopping.bill.BillListsAct
import com.baojia.mebike.util.StatusUtils
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import kotlinx.android.synthetic.main.activity_about_exclusive.*
import kotlinx.android.synthetic.main.layout_list_nodata.*

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.aboutexclusive
 * @author lycc1
 * @time 2018/12/24 17:05
 * @class describe
 * @class 中文描述 了解专享
 */
class AboutExclusiveAct : BaseActivity(), AboutExclusiveContract.View, View.OnClickListener {
    override fun setListProduct(data: ListProductBean?) {
        data?.data?.let {
            if (data.data.pmallBannerList.isEmpty() && data.data.pmallProductBoList.isEmpty()) {
                Toast.show(this, "暂无数据")
                finish()
                return
            }
            if (data.data.pmallBannerList.isEmpty()) {
                banner.visibility = View.GONE
            } else {
                banner.visibility = View.VISIBLE
                mBannerDatas.clear()
                mBannerDatas.addAll(it.pmallBannerList)
                banner.start(mBannerDatas, height)
            }
            if (it.pmallProductBoList.isEmpty()) {
                llNodata.visibility = View.VISIBLE
                recyclerView.visibility = View.GONE
                return
            }
            llNodata.visibility = View.GONE
            recyclerView.visibility = View.VISIBLE
            mProductDatas.clear()
            mProductDatas.addAll(it.pmallProductBoList)
            mAdapter!!.notifyDataSetChanged()

        }
    }

    override fun setListData() {

    }

    override fun onClick(p0: View?) {

    }

    override fun setPresenter(presenter: AboutExclusiveContract.Presenter?) {
    }


    var mPresenter: AboutExclusiveContract.Presenter? = null

    companion object {
        fun openActivity(context: Context) {
            var intent = Intent(context, AboutExclusiveAct::class.java)
            context.startActivity(intent)
        }
    }


    override fun isVisibleTitleBar(): Boolean = false


    override fun layoutId(): Int = R.layout.activity_about_exclusive
    private val mBannerDatas = ArrayList<BannerData>()
    private val mProductDatas = ArrayList<ListProductBean.DataBean.PmallProductBoListBean>()

    var mAdapter: AboutExclusiveAdapter? = null
    var height = 0

    override fun bindView(savedInstanceState: Bundle?) {
        initTitleBar()
        mPresenter = AboutExclusivePresenter(this, this)
        //简单使用
        height = ToolBox.getDisplayMetrics().widthPixels * 483 / 375
        banner.layoutParams = LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, height)


        initRecyclerView()

        mPresenter?.getListProduct()

        StatusUtils.darkMode(this, false)
    }

    private fun initRecyclerView() {
        mAdapter = AboutExclusiveAdapter(this, mProductDatas, R.layout.adapter_about_exclusive)

        recyclerView.layoutManager = LinearLayoutManager(this)
        recyclerView.adapter = mAdapter

    }

    private fun initTitleBar() {

        setSupportActionBar(mToolbar)
        mToolbar.setNavigationIcon(R.mipmap.back_icon)
        mToolbar.setBackgroundColor(ContextCompat.getColor(this, R.color.transparent))
        supportActionBar!!.setDisplayShowTitleEnabled(false)
        mRightButton.setOnClickListener(this)
        mToolbar.setNavigationOnClickListener { view ->
            if (isSetBackClick) {
                setLeftButtonOnClickListener()
            }
        }

        mRightButton.text = ToolBox.getString(R.string.mine_bill)
        mToolbar.setNavigationIcon(R.mipmap.back_white_icon)
        mRightButton.setTextColor(resources.getColor(R.color.button_text_color))
        mRightButton.setOnClickListener { BillListsAct.openActivity(this) }

    }


    override fun onDestroy() {
        super.onDestroy()
        banner?.bannerShutdown()
    }
}