package com.baojia.mebike.feature.exclusive.shopping.backAddress

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.baojia.mebike.R
import com.baojia.mebike.R.id.*
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.feature.exclusive.shopping.selectBackAddress.SelectBackAddressActivity
import com.baojia.mebike.feature.join.details.JoinDetailsActivity
import com.baojia.mebike.util.SoftHideKeyBoardUtil
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import kotlinx.android.synthetic.main.layout_buy_bike_bottom.*
import kotlinx.android.synthetic.main.layout_input_back_address.*

class InputBackAddressActivity : BaseActivity() {


    companion object {
        @JvmStatic
        fun startForResult(activity: Activity, requestCode :Int,address:String?,name:String?
                           ,phone:String?,desc:String?,takeLatitude:Double?,takeLongitude:Double?) {
            val intent = Intent()
            intent.setClass(activity, InputBackAddressActivity::class.java)
            intent.putExtra("address",address)
            intent.putExtra("name",name)
            intent.putExtra("phone",phone)
            intent.putExtra("desc",desc)
            intent.putExtra("takeLatitude",takeLatitude)
            intent.putExtra("takeLongitude",takeLongitude)
            activity.startActivityForResult(intent, requestCode)
        }
    }

    private var address = ""
    private var takeLongitude = 0.0
    private var takeLatitude = 0.0

    override fun layoutId(): Int = R.layout.activity_back_address

    override fun isVisibleTitleBar(): Boolean = true

    override fun setTitle(): String = "输入收车地址"

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            address = it.getStringExtra("address")
            if (address.isNotEmpty()){
                inputBackAddressDescTv.setText(address)
            }

            inputBackAddressDetailEt.setText(it.getStringExtra("desc"))
            inputBackAddressNameEt.setText(it.getStringExtra("name"))
            inputBackAddressPhoneEt.setText(it.getStringExtra("phone"))
            takeLatitude=  it.getDoubleExtra("takeLatitude",0.0)
            takeLongitude=  it.getDoubleExtra("takeLongitude",0.0)
        }

        buyBikeBottomViewOkLeftTv.text = "取消"
        buyBikeBottomViewOkRightTv.text = "确认收车地址"

        setViewClickDuration(inputBackAddressDescTv, 1)
        setViewClickDuration(buyBikeBottomViewOkRightTv, 1)
        setViewClickDuration(buyBikeBottomViewOkLeftTv, 1)

        SoftHideKeyBoardUtil.assistActivity(this)
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            inputBackAddressDescTv -> {
                SelectBackAddressActivity.startForResult(this,66)
            }
            buyBikeBottomViewOkRightTv -> {
                if (isNull())return
                val intent = Intent()
                intent.putExtra("address",address)
                intent.putExtra("name",inputBackAddressNameEt.text.toString())
                intent.putExtra("phone",inputBackAddressPhoneEt.text.toString())
                intent.putExtra("desc",inputBackAddressDetailEt.text.toString())
                intent.putExtra("takeLatitude",takeLatitude)
                intent.putExtra("takeLongitude",takeLongitude)
                setResult(12,intent)
                finish()
            }
            buyBikeBottomViewOkLeftTv -> {
                setResult(11)
                finish()
            }
        }
    }

    override fun setLeftButtonOnClickListener() {
        setResult(11)
        super.setLeftButtonOnClickListener()
    }

    override fun onBackPressed() {
        setResult(11)
        super.onBackPressed()
    }

    private fun isNull(): Boolean {
        if (inputBackAddressNameEt.text.toString().isEmpty()) {
            Toast.show(this, "请输入您的姓名")
            return true
        }
        if (inputBackAddressPhoneEt.text.toString().isEmpty()) {
            Toast.show(this, "请输入您的联系电话")
            return true
        }
        if (inputBackAddressDescTv.text.toString().equals("选择您的收车地址")) {
            Toast.show(this, "请选择您的收车地址")
            return true
        }
//        if (inputBackAddressDetailEt.text.toString().isEmpty()) {
//            Toast.show(this, "请输入您的地址备注")
//            return true
//        }

        return false
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == 66 && resultCode == 12){
            data?.let {
                address=  it.getStringExtra("address")
                takeLatitude=  it.getDoubleExtra("takeLatitude",0.0)
                takeLongitude=  it.getDoubleExtra("takeLongitude",0.0)
                inputBackAddressDescTv.setTextColor(ToolBox.getColor(R.color.text_first_color))

            }
            inputBackAddressDescTv.setText(address)
        }
    }
}