package com.baojia.mebike.feature.exclusive.shopping.bill

import android.content.Context
import android.text.SpannableString
import android.text.Spanned
import android.text.style.ForegroundColorSpan
import android.widget.TextView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.shopping.MineOrderBean
import com.baojia.mebike.feature.exclusive.shopping.buyResult.BuyResultActivity
import com.baojia.mebike.feature.exclusive.shopping.orderprogress.BuyOrderProgressAct
import com.baojia.mebike.util.Toast

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.bill
 * @author lycc1
 * @time 2018/12/25 15:03
 * @class describe
 * @class 中文描述
 */
class BillListAdapter(val context: Context, list: ArrayList<MineOrderBean.DataBean>, layoutId: Int)
    : BaseCommonAdapter<MineOrderBean.DataBean>(context, list, layoutId) {
    override fun convert(holder: BaseViewHolder?, list: MutableList<MineOrderBean.DataBean>?, position: Int) {
        var bean = list?.get(position) ?: return
        holder?.setText(R.id.billTypePrice, "¥" + bean.orderAmount.toString())
        holder?.setText(R.id.billTypeTip, bean.goodsTypeDesc)
        holder?.setText(R.id.billTypeTime, bean.createTime)
        holder?.setText(R.id.billTypeTitle, bean.goodsTypeMessage)
        holder?.setImageUrl(R.id.billTypeIco, bean.pmallProduct?.imgUrl
                ?: "", R.drawable.pic_holder_activitycenter)

//        var configText = holder?.findView<TextView>(R.id.billTypeTip)
//        stringSpanText(configText, bean.goodsDescs)

        when (bean.orderStatus) {
            0 ->
                holder?.setImageResource(R.id.billTypeStatueIco, R.mipmap.ico_bill_unpay)
            1 ->
                holder?.setImageResource(R.id.billTypeStatueIco, R.mipmap.ico_bill_payed)
            3 ->
                holder?.setImageResource(R.id.billTypeStatueIco, R.mipmap.ico_bill_unreceive)
            5 ->
                holder?.setImageResource(R.id.billTypeStatueIco, R.mipmap.ico_bill_receive)
            6 ->
                holder?.setImageResource(R.id.billTypeStatueIco, R.mipmap.ico_bill_earned)
        }

    }

//
//    fun stringSpanText(text: TextView?, desc: MutableList<MineOrderBean.DataBean.GoodsDescsBean>) {
//        if (desc.isEmpty()) {
//            return
//        }
//        for (it in desc) {
//            var spannableString = SpannableString(it.desc)
//            spannableString.setSpan(
//                    ForegroundColorSpan(context.resources.getColor(if (it.color == 1) R.color.focus_text_color else R.color.text_third_color)),
//                    0,
//                    spannableString.length,
//                    Spanned.SPAN_INCLUSIVE_EXCLUSIVE
//            )
//            text?.append(spannableString)
//            if (it != desc[desc.size - 1]) {
//                text?.append("\n")
//            }
//
//        }
//    }
}