package com.baojia.mebike.feature.exclusive.shopping.bill

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.widget.ImageView
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseRefreshActivity
import com.baojia.mebike.data.response.shopping.MineOrderBean
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.BillListsContract
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.BillListsPresenter
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikeConfigActivity
import com.baojia.mebike.feature.exclusive.shopping.buyResult.BuyResultActivity
import com.baojia.mebike.feature.exclusive.shopping.orderprogress.BuyOrderProgressAct
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.ToolBox
import kotlinx.android.synthetic.main.layout_nodata.*
import kotlinx.android.synthetic.main.layout_recyclerview_only.*

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.bill
 * @author lycc1
 * @time 2018/12/25 14:43
 * @class describe
 * @class 中文描述
 */
class BillListsAct : BaseRefreshActivity<BillListsContract.Presenter, BillListsContract.View>(), BillListsContract.View {
    override fun setCenterTitle(): String = "账单"

    override fun setListProduct(it: List<MineOrderBean.DataBean>,refresh : Boolean) {
        if (refresh){
            mDatas.clear()
        }
        mDatas.addAll(it)
        billAdapter?.notifyDataSetChanged()
    }

    override fun initAdapter() {
        billAdapter = BillListAdapter(this, mDatas, R.layout.adapter_bill_list)
        recyclerview.adapter = billAdapter

        val manager = LinearLayoutManager(this, RecyclerView.VERTICAL, false)
        recyclerview.layoutManager = manager
        recyclerview.setHasFixedSize(true)
        recyclerview.setBackgroundColor(ToolBox.getColor(R.color.background_color))
        val padding = ToolBox.dip2px(15f);
        recyclerview.setPadding(padding, 0, padding, 0)

        billAdapter?.setOnItemClickListner { _, position ->
            run {
                var item = mDatas[position]
                item ?: return@run
                when (item.orderStatus) {
//                    NO_PAY(0, "待支付"),
//                    PAYED(1, "已支付"),
//                    NO_GET(3, "待收车"),
//                    GETED(5, "已收车"),
//                    ENDED(6, "已过期"),

                    0 -> BuyBikeConfigActivity.start(this, 1, "", "", "", "", 0, 0, 0, item.orderNo)
                    5,6 -> BuyOrderProgressAct.openActivity(this, item.orderNo, item.orderStatus, item.goodsType, "")
                    else -> {
                        if (item.goodsType == 1 || item.goodsType == 2){
                            BuyOrderProgressAct.openActivity(this, item.orderNo, item.orderStatus, item.goodsType, "")
                        }else{
                            BuyResultActivity.openActivity(this, item.orderNo, item.goodsType)
                        }
                    }
                }
            }
        }

    }

    override fun onRefresh() {
        mPresenter?.onRefresh()
    }

    override fun getAdapter(): BaseCommonAdapter<Any?> {
        return billAdapter as BaseCommonAdapter<Any?>;
    }

    override fun onLoadMore() {
        mPresenter?.onLoadMore()
    }

    var billAdapter: BillListAdapter? = null;
    var mPresenter: BillListsContract.Presenter? = null
    private val mDatas = ArrayList<MineOrderBean.DataBean>()
    override fun isVisibleTitleBar() = true

    companion object {
        fun openActivity(context: Context) {
            var intent = Intent(context, BillListsAct::class.java)
            context.startActivity(intent)
        }
    }

    override fun showNoDataPage() {
        super.showNoDataPage()
        billAdapter?.let {
            if (it.itemCount < 1) {
                noDataTextView.text = "无账单信息"
                noDataTextView.setTextColor(ToolBox.getColor(R.color.text_third_color))
                noDataImageView.scaleType = ImageView.ScaleType.CENTER_INSIDE
                ImageLoader.loadLocalImage(R.mipmap.ico_list_no_data, noDataImageView)
            }
        }
    }


    override fun bindView(savedInstanceState: Bundle?) {
        super.bindView(savedInstanceState)
        mPresenter = BillListsPresenter(this, this)

    }
}