package com.baojia.mebike.feature.exclusive.shopping.aboutexclusive

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.shopping.MineOrderBean
import com.baojia.mebike.feature.exclusive.shopping.bill.BillListsModel

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.aboutexclusive
 * @author lycc1
 * @time 2018/12/24 21:10
 * @class describe
 * @class 中文描述
 */
class BillListsPresenter(val mContext: Activity?, val mView: BillListsContract.View) : BasePresenter(mContext), BillListsContract.Presenter {
    override fun onLoadMore() {
        getBillList(currentPage, false)
    }

    override fun onRefresh() {
        getBillList(currentPage, true)
    }

    var currentPage = 1

    var mModel: BillListsModel? = null
    fun getBillList(page: Int, isRefash: Boolean) {
        if (isRefash) {
            currentPage = 1
        } else {
            currentPage += 1
        }
        addDisposable(mModel?.getListConfig(currentPage, object : HttpCallback<MineOrderBean?>() {
            override fun onSucceed(data: MineOrderBean?) {
                super.onSucceed(data)
                if (isRefash) mView.refreshDataSucceed() else mView.loadMoreDataSucceed()
                data?.data?.let {
                    if (it.isEmpty()) {

                        mView.showNoDataPage()
                        return
                    }
                    mView.setListProduct(it,isRefash)

                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                if (isRefash) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                if (isRefash) mView.refreshDataFailed(message) else mView.loadMoreDataFailed(message)
                mView.showErrorPage()

            }
        }))
    }

    init {
        mView.setPresenter(this)
        mModel = BillListsModel(mContext!!);
    }
}