package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.Fragment
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.feature.exclusive.shopping.bill.BillListsAct
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.fragment.*
import com.baojia.mebike.feature.exclusive.shopping.buyResult.BuyResultActivity
import com.baojia.mebike.feature.exclusive.shopping.orderprogress.BuyOrderProgressAct
import com.baojia.mebike.feature.main.MainActivity
import com.baojia.mebike.util.AppManager
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.ToolBox
import com.baojia.mebike.util.WechatPayUtils
import kotlinx.android.synthetic.main.activity_buy_bike_config.*

open class BuyBikeConfigActivity : BaseActivity(), BuyBikeConfigContract.View, PayListener {


    companion object {
        //goodsType（1：整车购买 2：买车租电 3：整车租赁 , 4直接跳转支付）
        //type（1 直接跳支付 0 不管）
        @JvmStatic
        fun start(activity: Activity, type: Int, bikeTitle: String, maxPower: String, maxSpeed: String, bikeImgUrl: String, goodsType: Int, productId: Int, goodsId: Int, orderNo: String?) {
            val intent = Intent()
            intent.setClass(activity, BuyBikeConfigActivity::class.java)
            intent.putExtra("goodsType", goodsType)
            intent.putExtra("type", type)
            intent.putExtra("productId", productId)
            intent.putExtra("goodsId", goodsId)
            intent.putExtra("orderNo", orderNo)
            intent.putExtra("maxPower", maxPower)
            intent.putExtra("maxSpeed", maxSpeed)
            intent.putExtra("bikeImgUrl", bikeImgUrl)
            intent.putExtra("bikeTitle", bikeTitle)
            activity.startActivity(intent)
        }
    }

    private var currentFragment: Fragment? = Fragment()
    //    private val plantFragment = BuyBikePlantFragment()
    private val plantFragment2 = BuyBikePlantNewFragment()
    private val colorSelectFragment = BuyBikeColorSelectFragment()
    private val getBikeTypeFragment = BuyBikeGetBikeTypeFragment()
    private val orderConfirmFragment = BuyBikeOrderConfirmFragment()
    private val payFragment = BuyBikePayFragment()

    private var presenter: BuyBikeConfigPresenter? = null
    private var isFirstConfirmOrder = true

    //（1：整车购买 2：买车租电 3：整车租赁 ）
    private var goodsType = 0
    //（1 直接跳支付 0 不管）
    private var type = 0
    private var goodsId = 0
    private var productId = 0
    private var orderNo = ""
    open var bikeImgUrl = ""
    open var maxPower = ""
    open var maxSpeed = ""
    open var bikeTitle = ""
    private var takeLongitude = 0.0
    private var takeLatitude = 0.0
    //收车人姓名
    private var takeUserName = ""
    //收车人电话
    private var takeUserPhone = ""
    //收车人地址备注
    private var takeUserAddr = ""
    //收车人地址
    private var takeUserAddrRemarks = ""
    //取车方式（1：上门送货 2：自行取车）
    private var takeType = 1
    // 支付方式 1：微信支付 2：支付宝支付
    private var payMethod = 1
    //取车位置选中位置
    open var takeTypeSelectPosition = 0
    //颜色选中位置
    open var colorSelectPosition = 0
    //专享期限选中位置
//    open var deadTimeSelectPosition = -1
    //紧急换电选中位置
//    open var changePowerSelectPosition = -1
    //总数据
    open var dataBean: BuyBikeConfigResponse.DataBean? = null

    override fun layoutId(): Int = R.layout.activity_buy_bike_config

    override fun isVisibleTitleBar(): Boolean = true

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            type = it.getIntExtra("type", 0)
            goodsType = it.getIntExtra("goodsType", 0)
            goodsId = it.getIntExtra("goodsId", 0)
            productId = it.getIntExtra("productId", 0)
            orderNo = it.getStringExtra("orderNo")
            maxSpeed = it.getStringExtra("maxSpeed")
            bikeImgUrl = it.getStringExtra("bikeImgUrl")
            maxPower = it.getStringExtra("maxPower")
            bikeTitle = it.getStringExtra("bikeTitle")
        }

        presenter = BuyBikeConfigPresenter(this, this)

        if (type == 1) {
            switchFragment(payFragment)
        } else {
            switchFragment(plantFragment2)
            presenter?.getAllData()
        }
//        if (goodsType == 1) {
//            buyBikeServiceTv.visibility = View.GONE
//            switchFragment(colorSelectFragment)
//        } else {
//            buyBikeServiceTv.visibility = View.VISIBLE
//            switchFragment(plantFragment)

//        }


    }

    //fragment取消按钮
    public fun clickCancle() {
        if (currentFragment is BuyBikePlantNewFragment) {
            finish()
        } else if (currentFragment is BuyBikeColorSelectFragment) {
            switchFragment(plantFragment2)
        } else if (currentFragment is BuyBikeGetBikeTypeFragment) {
            switchFragment(colorSelectFragment)
        } else if (currentFragment is BuyBikeOrderConfirmFragment) {
            switchFragment(getBikeTypeFragment)
        } else if (currentFragment is BuyBikePayFragment) {
//            switchFragment(payFragment)
        }
    }

    //fragment确定按钮
    public fun clickOk() {
        if (currentFragment is BuyBikePlantNewFragment) {
            switchFragment(colorSelectFragment)
        } else if (currentFragment is BuyBikeColorSelectFragment) {
            switchFragment(getBikeTypeFragment)
        } else if (currentFragment is BuyBikeGetBikeTypeFragment) {
            switchFragment(orderConfirmFragment)
        } else if (currentFragment is BuyBikeOrderConfirmFragment) {
            presenter?.buyConfigCommit()
        } else if (currentFragment is BuyBikePayFragment) {
//            presenter?.
            presenter?.prePay()
        }
    }

    //专有跳支付页
    override fun clickCommit() {
        switchFragment(payFragment)
    }


    //tabfragment，切换
    private fun switchFragment(targetFragment: Fragment) {
        if (currentFragment === targetFragment) {
            return
        }
        val transaction = supportFragmentManager.beginTransaction()
        currentFragment?.let {
            transaction.hide(it)
        }
        if (!targetFragment.isAdded) {
            transaction.add(R.id.buyBikeConfigFrameLayout, targetFragment)
                    .commitAllowingStateLoss()
        } else {
            transaction
                    .show(targetFragment)
                    .commitAllowingStateLoss()
        }
        currentFragment = targetFragment
        changAllTabSmall()
        if (currentFragment is BuyBikePlantNewFragment) {
            buyBikeServiceTv.textSize = 25f
            buyBikeServiceTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
        } else if (currentFragment is BuyBikeColorSelectFragment) {
            buyBikeColorTv.textSize = 25f
            buyBikeColorTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
        } else if (currentFragment is BuyBikeGetBikeTypeFragment) {
            buyBikeGetTypeTv.textSize = 25f
            buyBikeGetTypeTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
        } else if (currentFragment is BuyBikeOrderConfirmFragment) {
            buyBikeOrderConfirmTv.textSize = 25f
            buyBikeOrderConfirmTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
            if (!isFirstConfirmOrder) {
                orderConfirmFragment.refreshData()
            }
            isFirstConfirmOrder = false

        } else if (currentFragment is BuyBikePayFragment) {
            buyBikeOrderPayTv.textSize = 25f
            buyBikeOrderPayTv.setTextColor(ToolBox.getColor(R.color.text_first_color))
        }

    }

    //tab字体处理
    private fun changAllTabSmall() {
        buyBikeServiceTv.textSize = 15f
        buyBikeColorTv.textSize = 15f
        buyBikeGetTypeTv.textSize = 15f
        buyBikeOrderConfirmTv.textSize = 15f
        buyBikeOrderPayTv.textSize = 15f
        buyBikeServiceTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeColorTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeGetTypeTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeOrderConfirmTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
        buyBikeOrderPayTv.setTextColor(ToolBox.getColor(R.color.text_second_color))
    }

    override fun onResume() {
        super.onResume()
        if (currentFragment is BuyBikePayFragment) {
            checkPay()
        }
    }

    override fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean) {
        if (dataBean.payChannelId == 1) {
            WechatPayUtils.wechatPay(this, dataBean.appid, dataBean.partnerid, dataBean.prepayid,
                    dataBean.wxpackage, dataBean.noncestr, dataBean.timestamp,
                    dataBean.sign)

        } else if (dataBean.payChannelId == 2) {
            AliPayManager(this)
                    .alipayV2(this, dataBean.orderInfo)
        }
    }

    override fun onFailed(msg: String?) {
        Toast.show(this, msg)
    }

    override fun onSuccess() {
    }

    override fun paySuccess() {
        when (goodsType) {
            3 -> BuyResultActivity.openActivity(this, orderNo, goodsType)
            1, 2 -> BuyOrderProgressAct.openActivity(this, orderNo, 2, goodsType, "")
        }
//        if (AppManager.getInstance().isContain(BillListsAct::class.java)) {
//            this.finish()
//        } else {
            AppManager.getInstance().startActivity(MainActivity::class.java)
//        }

    }


    override fun payMethod(): Int = payMethod

    override fun goodsType(): Int = goodsType

    override fun productColorId(): Int {
        dataBean?.colors?.let {
            if (colorSelectPosition == -1) {
                return -1
            }
            return it[colorSelectPosition].colorId
        }
        return -1
    }

    override fun takeType(): Int = takeType

    override fun packageItemIds(): String {
        var ids = ""
        dataBean?.packages?.let {
            for (index in it.indices) {
                for (indexIn in it[index].packageItems.indices) {
                    if (it[index].packageItems[indexIn].isClick) {
                        ids = ids + it[index].packageItems[indexIn].packageItemId + ","
                    }
                }
            }

        }
        return ids
    }

    override fun takeUserName(): String = takeUserName

    override fun takeUserPhone(): String = takeUserPhone

    override fun takeUserAddrRemarks(): String = takeUserAddrRemarks

    override fun takeUserAddr(): String = takeUserAddr

    override fun productId(): Int = productId

    override fun goodsId(): Int = goodsId

    override fun orderNo(): String = orderNo
    override fun setOrderNo(orderNo: String) {
        this.orderNo = orderNo
    }

    override fun takeLongitude() = takeLongitude

    override fun takeLatitude() = takeLatitude

    override fun setPresenter(presenter: BuyBikeConfigContract.Presenter?) {
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == 66 && resultCode == 12) {
            data?.let {
                takeUserAddr = it.getStringExtra("address")
                takeUserAddrRemarks = it.getStringExtra("desc")
                takeUserName = it.getStringExtra("name")
                takeUserPhone = it.getStringExtra("phone")
                takeLatitude=  it.getDoubleExtra("takeLatitude",0.0)
                takeLongitude=  it.getDoubleExtra("takeLongitude",0.0)
                getBikeTypeFragment.setActivityResultData(takeUserAddr)
//                Toast.show(this, "${it.getStringExtra("address")} ${it.getStringExtra("desc")}")
            }
        }
    }

    //取车回调（1：上门送货 2：自行取车）
    fun setTakeType(takeType: Int) {
        this.takeType = takeType
    }

    fun setPayType(payType: Int) {
        this.payMethod = payType
    }

    //查单
    fun checkPay() {
        presenter?.checkOrderPayStatus()
    }

    //获取支付页面数据
    fun getPayDetail() {
        presenter?.payDetailData()
    }

    //修改plant页面原始数据
    fun changePlantData(one: Int, two: Int, isClick: Boolean) {
        dataBean?.packages?.let {
            it[one].packageItems[two].isClick = isClick
        }
    }

    override fun setAllData(dataBean: BuyBikeConfigResponse.DataBean) {
        this.dataBean = dataBean
        dataBean.packages?.let {
            //可以设置默认选中第一个

        }

        if (currentFragment is BuyBikePlantNewFragment) {
            plantFragment2.refreshData()
        }
        if (currentFragment is BuyBikeColorSelectFragment) {
            colorSelectFragment.refreshData()
        }
    }

    override fun setPayDetailData(dataBean: BuyConfigCommitResponse.DataBeanX) {
        if (currentFragment is BuyBikePayFragment) {
            payFragment.setData(dataBean)
        }
    }

}