package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse

class BuyBikeConfigContract {

    interface View : IBaseView<Presenter> {

        /**
         * 支付成功回调
         * @param dataBean
         */
        fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean)

        /**
         * 支付方式
         * @return
         */
        fun payMethod(): Int

        /**
         * 商品类型（1：整车购买 2：买车租电 3：整车租赁
         */
        fun goodsType() :Int

        /**
         * 车颜色
         */
        fun productColorId() :Int

        /**
         * 取车方式（1：上门送货 2：自行取车）
         */
        fun takeType() :Int
        fun productId() :Int
        fun goodsId() :Int

        /**
         * 套餐Ids(3,6)
         */
        fun packageItemIds() :String
        fun takeUserName() :String
        fun takeUserPhone() :String
        fun takeUserAddrRemarks() :String
        fun takeUserAddr() :String
        fun orderNo() :String
        fun setOrderNo(orderNo :String)

        fun setAllData(dataBean: BuyBikeConfigResponse.DataBean)
        fun setPayDetailData(dataBean: BuyConfigCommitResponse.DataBeanX)

        //订单确认跳转支付页
        fun clickCommit()

        fun paySuccess()
        fun takeLongitude() :Double
        fun takeLatitude() :Double

    }

    interface Presenter : IBasePresenter {
        /**
         * 支付
         */
        fun prePay()

        /**
         * 查询订单支付状态
         */
        fun checkOrderPayStatus()

        //订单提交
        fun buyConfigCommit()

        fun getAllData()

        fun payDetailData()

    }
}