package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.util.Toast

class BuyBikeConfigPresenter(activity: Activity, val view: BuyBikeConfigContract.View) : BasePresenter(activity), BuyBikeConfigContract.Presenter {

    val model = BuyBikeConfigModel(activity)

    override fun prePay() {
        addDisposable(model.orderPay(view.orderNo(), view.payMethod(), object : HttpCallback<PayByOtherResponse.DataBean>() {
            override fun onSucceed(data: PayByOtherResponse.DataBean) {
                super.onSucceed(data)
                view.orderPaySucceed(data)
                data?.let {
                    view.setOrderNo(it.orderNo)
                }
            }
        }))
    }

    override fun checkOrderPayStatus() {
        view.orderNo().let {
            model.checkOrderPayStatus(it, 5, object : HttpCallback<BaseResponse?>() {
                override fun onSucceed(data: BaseResponse?) {
                    super.onSucceed(data)
                    data?.let {
                        view.paySuccess()
                    }
                }
            })
        }
    }

    override fun buyConfigCommit() {
        addDisposable(model.buyConfigCommit(view.goodsType(), view.goodsId(), view.productId(),
                view.productColorId(), view.packageItemIds(), view.takeType(), view.takeUserName(),
                view.takeUserPhone(), view.takeUserAddrRemarks(), view.takeUserAddr(),
                view.takeLatitude(),view.takeLongitude(),object : HttpCallback<BuyConfigCommitResponse>() {
            override fun onSucceed(data: BuyConfigCommitResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                   view.setOrderNo(it.orderNo)
                }

                view.clickCommit()
            }
        }))
    }

    override fun payDetailData() {
        addDisposable(model.payDetailData(view.orderNo(), object : HttpCallback<BuyConfigCommitResponse>() {
            override fun onSucceed(data: BuyConfigCommitResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    view.setPayDetailData(it)
                }
            }
        }))
    }


    override fun getAllData() {
        addDisposable(model.getAllData(view.productId(), view.goodsId(), object : HttpCallback<BuyBikeConfigResponse>() {
            override fun onSucceed(data: BuyBikeConfigResponse?) {
                super.onSucceed(data)
                data?.data?.let {
                    view.setAllData(it)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(context, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(-1, message)
            }
        }))
    }

}