package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.fragment

import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseFragmentNew
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikeConfigActivity
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.ColorSelectAdapter
import com.baojia.mebike.imageloader.ImageLoader
import kotlinx.android.synthetic.main.fragment_buy_bike_color_select.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom.*
import kotlinx.android.synthetic.main.layout_buy_bike_info.*

class BuyBikeColorSelectFragment :BaseFragmentNew() {
    override fun layoutId(): Int = R.layout.fragment_buy_bike_color_select

    private var mData  = arrayListOf<BuyBikeConfigResponse.DataBean.ColorsBean>()
    private var adapter : ColorSelectAdapter<BuyBikeConfigResponse.DataBean.ColorsBean>? = null

    override fun bindView() {

        setViewClickDuration(buyBikeBottomViewOkLeftTv,1)
        setViewClickDuration(buyBikeBottomViewOkRightTv,1)

        buyBikeBottomViewOkRightTv.text = "确认颜色"

        colorAndTypeRecyclerView.layoutManager = GridLayoutManager(activity,4)
        adapter = ColorSelectAdapter<BuyBikeConfigResponse.DataBean.ColorsBean>(activity, mData, R.layout.item_color_select)
        colorAndTypeRecyclerView.adapter = adapter

        adapter?.setOnItemClickListner { _, position ->
            run {
              if (mData.isEmpty())return@setOnItemClickListner
                for (item in mData) {
                    item.isClick = false
                }
                mData[position].isClick = true
                getFatherActivity()?.colorSelectPosition = position
                adapter?.notifyDataSetChanged()
            }
        }

        refreshData()


    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when(view){
            buyBikeBottomViewOkLeftTv -> getFatherActivity()?.clickCancle()
            buyBikeBottomViewOkRightTv -> getFatherActivity()?.clickOk()
        }
    }


    open fun refreshData(){
        getFatherActivity()?.dataBean?.colors?.let {
            mData.clear()
            mData.addAll(it)
            if (mData.isNotEmpty()){
                mData[0].isClick = true
            }
            adapter?.notifyDataSetChanged()
        }

        ImageLoader.loadUrl(bugBikePicImageView,getFatherActivity()?.bikeImgUrl,R.drawable.pic_bike_buy)
        buyBikeInfoLeftContentTv.text = getFatherActivity()?.maxSpeed
        buyBikeInfoRightContentTv.text = getFatherActivity()?.maxPower
    }


    fun getFatherActivity() : BuyBikeConfigActivity? = activity as BuyBikeConfigActivity
}