package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.fragment

import android.app.Activity
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseFragmentNew
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.feature.exclusive.shopping.backAddress.InputBackAddressActivity
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikeConfigActivity
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.GetBikeTypeAdapter
import com.baojia.mebike.feature.exclusive.shopping.nearBike.NearBikeActivity
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.Toast
import kotlinx.android.synthetic.main.fragment_buy_bike_color_select.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom.*
import kotlinx.android.synthetic.main.layout_buy_bike_info.*

class BuyBikeGetBikeTypeFragment : BaseFragmentNew() {

    var mData: ArrayList<BuyBikeConfigResponse.DataBean.TakeTypeBean> = arrayListOf()

    var isAddressReturn = false
    var clickTag = 0
    var data : BuyBikeConfigResponse.DataBean? = null

    override fun layoutId(): Int = R.layout.fragment_buy_bike_color_select


    private var adapter: GetBikeTypeAdapter? = null

    override fun bindView() {

        colorAndTypeTv.text = "选择获取方式"

        buyBikeBottomViewOkRightTv.text = "确认获取方式"

        adapter = GetBikeTypeAdapter(activity, mData, R.layout.item_buy_bike_getbike_type)
        colorAndTypeRecyclerView.layoutManager = LinearLayoutManager(activity)
        colorAndTypeRecyclerView.adapter = adapter

        setViewClickDuration(buyBikeBottomViewOkLeftTv, 1)
        setViewClickDuration(buyBikeBottomViewOkRightTv, 1)

        adapter?.setOnItemClickListner { _, position ->
            run {
                setAllUnclick()
                mData[position].isClick = true
                getFatherActivity()?.setTakeType(mData[position].tag)
                getFatherActivity()?.takeTypeSelectPosition = position
//                when (mData[position].tag) {
//                    1 -> canPass = isAddressReturn
//                    2 -> canPass = true
//                }
                clickTag = mData[position].tag
                adapter?.notifyDataSetChanged()
            }
        }
        adapter?.setOnItemChildViewClickListner { _, position ->
            run {
                when (mData[position].tag) {
                    1 -> {
                        InputBackAddressActivity.startForResult(activity as BuyBikeConfigActivity, 66,getFatherActivity()?.takeUserAddr()
                                ,getFatherActivity()?.takeUserName(),getFatherActivity()?.takeUserPhone(),getFatherActivity()?.takeUserAddrRemarks()
                                ,getFatherActivity()?.takeLatitude(),getFatherActivity()?.takeLongitude())
                    }
                    2 -> {
                        NearBikeActivity.start(activity as Activity, null,Bundle(),0)
                    }
                }
            }
        }

        refreshData()

    }

    fun setAllUnclick() {
        for (item in mData) {
            item.isClick = false
        }
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            buyBikeBottomViewOkLeftTv -> (activity as BuyBikeConfigActivity).clickCancle()
            buyBikeBottomViewOkRightTv -> {
                if (clickTag == 0) {
                    Toast.show(activity, "请选择获取方式")

                    return
                }
                if (clickTag == 1 && !isAddressReturn){
                    Toast.show(activity, "请配置收车地址")
                    return
                }
               getFatherActivity()?.clickOk()
            }


        }
    }

    public fun setActivityResultData(address: String) {
        isAddressReturn = true
        if (mData.isEmpty())return
        for (index in mData.indices){
            if (mData[index].tag == 1){
                mData[index].button = "更改"
                mData[index].address = address
                mData[index].isSelectAddress = true
                mData[index].isClick = true
                clickTag = 1
                getFatherActivity()?.takeTypeSelectPosition = index
            }else{
                mData[index].isClick = false
            }
        }
        adapter?.notifyDataSetChanged()



    }

    open fun refreshData(){
        data = getFatherActivity()?.dataBean
        data?:return
        getFatherActivity()?:return
        if (data!!.takeType.isEmpty())return
        mData.clear()
        mData.addAll(data!!.takeType)
        for (index in mData.indices){
            if (mData[index].tag == 1){
               mData[index].button = "输入收车地址"
            }else if (mData[index].tag == 2){
                mData[index].button = "查看附近车辆"
            }
        }
        adapter?.notifyDataSetChanged()

        ImageLoader.loadUrl(bugBikePicImageView,getFatherActivity()?.bikeImgUrl,R.drawable.pic_bike_buy)
        buyBikeInfoLeftContentTv.text = getFatherActivity()?.maxSpeed
        buyBikeInfoRightContentTv.text = getFatherActivity()?.maxPower

    }

    fun getFatherActivity() : BuyBikeConfigActivity? = activity as BuyBikeConfigActivity

}