package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.fragment

import android.view.View
import android.widget.TextView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseFragmentNew
import com.baojia.mebike.data.response.exclusive.shapping.BuyBikeConfigResponse
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikeConfigActivity
import com.baojia.mebike.imageloader.ImageLoader
import com.baojia.mebike.util.Toast
import kotlinx.android.synthetic.main.fragment_buy_bike_order_confirm.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom.*

class BuyBikeOrderConfirmFragment : BaseFragmentNew() {
    override fun layoutId(): Int = R.layout.fragment_buy_bike_order_confirm

    private var data: BuyBikeConfigResponse.DataBean? = null

    override fun bindView() {

        buyBikeBottomViewOkRightTv.text = "确认订单"

        setViewClickDuration(buyBikeBottomViewOkLeftTv, 1)
        setViewClickDuration(buyBikeBottomViewOkRightTv, 1)

        refreshData()
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            buyBikeBottomViewOkLeftTv -> (activity as BuyBikeConfigActivity).clickCancle()
            buyBikeBottomViewOkRightTv -> (activity as BuyBikeConfigActivity).clickOk()
        }
    }

    open fun refreshData() {
        data = getFatherActivity()?.dataBean
        data ?: return
        getFatherActivity() ?: return
        data?.packages?.let {
            orderConfrimPlantLinearLayout.removeAllViews()
            for (index in it.indices) {
                for (indexIn in it[index].packageItems.indices){
                    if (it[index].packageItems[indexIn].isClick){
                        var view =  layoutInflater.inflate(R.layout.item_confirm_order,null)
                        val title = view.findViewById<TextView>(R.id.orderConfrimTimeTitleTv)
                        val desc = view.findViewById<TextView>(R.id.orderConfrimTimeContentTv)
                        title.text = it[index].packageName
                        desc.text = it[index].packageItems[indexIn].description + "," + it[index].packageItems[indexIn].currentPriceText
                        orderConfrimPlantLinearLayout.addView(view)
                    }
                }


            }
        }


        if (getFatherActivity()?.colorSelectPosition != -1) {
            orderConfrimColorContentTv.text = "${data!!.colors[getFatherActivity()!!.colorSelectPosition].name}"
        }
        if (getFatherActivity()?.takeTypeSelectPosition != -1) {
            orderConfrimAddressContentTv.text = "${data!!.takeType[getFatherActivity()!!.takeTypeSelectPosition].title}"
            if (getFatherActivity()?.takeType() == 1){
                orderConfrimAddressDescTv.text = "${getFatherActivity()!!.takeUserAddr()}${getFatherActivity()!!.takeUserAddrRemarks()}"
            }else{
                orderConfrimAddressDescTv.text = ""
            }
        }

        ImageLoader.loadUrl(orderConfirmTypeBikeIv, getFatherActivity()?.bikeImgUrl)

        orderConfrimTypeContentTv.text = "${getFatherActivity()?.bikeTitle}"
        orderConfrimTypeDesc1Tv.text = "最高时速：${getFatherActivity()?.maxSpeed}"
        orderConfrimTypeDesc2Tv.text = "最大续航：${getFatherActivity()?.maxPower}"

    }

    fun getFatherActivity(): BuyBikeConfigActivity? = activity as BuyBikeConfigActivity
}