package com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.fragment

import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseFragmentNew
import com.baojia.mebike.data.response.exclusive.shapping.BuyConfigCommitResponse
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikeConfigActivity
import com.baojia.mebike.feature.exclusive.shopping.buyBikeConfig.BuyBikePayAdapter
import kotlinx.android.synthetic.main.fragment_buy_bike_pay.*
import kotlinx.android.synthetic.main.include_payment.*
import kotlinx.android.synthetic.main.layout_buy_bike_bottom_money.*

class BuyBikePayFragment : BaseFragmentNew() {
    override fun layoutId(): Int = R.layout.fragment_buy_bike_pay

    // 支付方式 1：微信支付 2：支付宝支付
    private var payMethod = 1
    private var payList: ArrayList<BuyConfigCommitResponse.DataBeanX.DataBean> = arrayListOf()
    private var adapter: BuyBikePayAdapter<BuyConfigCommitResponse.DataBeanX.DataBean>? = null

    override fun bindView() {

        paymentTitleTextView.visibility = View.GONE
        buyBikeBottomViewOkTv.text = "确认支付"
        setPayMethod(1)

        setViewClickDuration(wechatPayLayout, 1)
        setViewClickDuration(aliPayLayout, 1)
        setViewClickDuration(buyBikeBottomViewOkTv, 1)
        adapter = BuyBikePayAdapter(activity, payList, R.layout.item_buy_bike_pay)
        buyBikePayRecyclerView.layoutManager = LinearLayoutManager(activity)
//        buyBikePayRecyclerView.addItemDecoration( RecycleViewDivider(activity, RecyclerView.VERTICAL,
//                DensityUtil.dip2px(activity, 1F), R.color.line_color))
        buyBikePayRecyclerView.adapter = adapter
        getFatherActivity()?.getPayDetail()


    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            wechatPayLayout -> setPayMethod(1)
            aliPayLayout -> setPayMethod(2)
            buyBikeBottomViewOkTv -> getFatherActivity()?.clickOk()
        }
    }

    private fun setPayMethod(payWay: Int) {
        if (payWay == 1) {
            // 微信支付
            wechatSelectImageView.setImageResource(R.mipmap.selected_icon)
            aliSelectImageView.setImageResource(R.mipmap.unselected_icon)
        } else {
            // 支付宝支付
            aliSelectImageView.setImageResource(R.mipmap.selected_icon)
            wechatSelectImageView.setImageResource(R.mipmap.unselected_icon)
        }
        payMethod = payWay
        getFatherActivity()?.setPayType(payWay)
    }

    fun setData(data: BuyConfigCommitResponse.DataBeanX) {
        buyBikeBottomViewMoneyTv.text = "${data.orderAmount}"
        data.data?.let {
            payList.clear()
            payList.addAll(it)
        }
        adapter?.notifyDataSetChanged()

    }

    fun getFatherActivity() : BuyBikeConfigActivity? = activity as BuyBikeConfigActivity

}