package com.baojia.mebike.feature.exclusive.shopping.buyResult

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.shopping.ListProcessBean
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.BuyResultContract
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.BuyResultPresenter
import com.baojia.mebike.feature.exclusive.shopping.bill.BuyResultAdapter
import com.baojia.mebike.feature.exclusive.shopping.nearBike.NearBikeActivity
import com.baojia.mebike.util.JumpActivity
import kotlinx.android.synthetic.main.activity_buy_bike_result.*
import kotlinx.android.synthetic.main.include_bottom_common.*
import kotlinx.android.synthetic.main.item_buy_bike_getbike_type.*

class BuyResultActivity : BaseActivity(), BuyResultContract.View {


    private val mDatas = ArrayList<ListProcessBean.ProcessData.DataBean>()

    var mPresenter: BuyResultContract.Presenter? = null
    var mAdapter: BuyResultAdapter? = null
    var orderNo: String? = null
    var orderStatus = 0
    var goodsType = 0

    companion object {
        /**
         * @param  goodsType  1 整车订购（含电池）  2 整车订购（不含电池） 3 租车
         */
        fun openActivity(context: Context, orderNo: String, goodsType: Int) {
            var intent = Intent(context, BuyResultActivity::class.java)
            intent.putExtra("orderNo", orderNo)
            intent.putExtra("goodsType", goodsType)
            context.startActivity(intent)
        }
    }

    override fun layoutId(): Int = R.layout.activity_buy_bike_result

    override fun isVisibleTitleBar(): Boolean = true

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            orderNo = it.getStringExtra("orderNo")
            goodsType = it.getIntExtra("goodsType", 0)
        }
        mPresenter = BuyResultPresenter(this, this)
        mAdapter = BuyResultAdapter(this, mDatas, R.layout.adapter_order_progress)

        bottomViewOkLeftTv.text = "客服电话"
        bottomViewOkRightTv.text = "扫码取车"

        setViewClickDuration(bottomViewOkLeftTv, 1)
        setViewClickDuration(bottomViewOkRightTv, 1)


        buyBikeResultRecyclerView.layoutManager = LinearLayoutManager(this)
        buyBikeResultRecyclerView.adapter = mAdapter

        mPresenter?.getListProcess(orderNo)
    }


    override fun setListData(data: ListProcessBean?) {
        data?.data?.let {
            //取车类型（1：送车上门 2：自行取车）
            val isSelfGet = it.takeType == 2
            val string = if (isSelfGet) "查找附近专享车辆，自行获取" else it.takeaddr
            getBikeTypeItemInputAddressTv.text = "查看附近车辆"
            getBikeTypeItemInputAddressTv.visibility = if (isSelfGet) View.VISIBLE else View.GONE
            getBikeTypeItemInputAddressTv.setOnClickListener {
                var bundle = Bundle()
                bundle.putString("orderNo", orderNo)
                bundle.putInt("orderStatus", orderStatus)
                bundle.putInt("goodsType", goodsType)
                NearBikeActivity.start(this, orderNo!!, bundle, 1)
            }
            getBikeTypeItemDesc.text = string
            getBikeTypeItemTitle.text = it.title
            mDatas.clear()

            it.data?.let {
                if (it.isNotEmpty()) {
                    mDatas.addAll(it)
                }
            }
            mAdapter?.notifyDataSetChanged()
        }
    }


    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            bottomViewOkLeftTv -> JumpActivity.JumpContactService(this)
            bottomViewOkRightTv -> {
                var bundle = Bundle()
                bundle.putString("orderNo", orderNo)
                bundle.putInt("orderStatus", orderStatus)
                bundle.putInt("goodsType", goodsType)
                JumpActivity.JumpScanActivity(this, 4, bundle)
            }

        }
    }

    override fun setPresenter(presenter: BuyResultContract.Presenter?) {

    }
}