package com.baojia.mebike.feature.exclusive.shopping.changbattery

import android.content.Context
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.ChangBatteryListBean
import kotlinx.android.synthetic.main.activity_buy_order_progress.*


/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.orderprogress
 * @author lycc1
 * @time 2018/12/25 16:50
 * @class describe
 * @class 中文描述  换电进度查询
 */
class ChangeBatteryProgressAct : BaseActivity(), ChangeBatteryProgressContract.View {



    private val mDatas = arrayListOf<ChangBatteryListBean.DataBean.ChangeVoBean>()

    var mPresenter: ChangeBatteryProgressContract.Presenter? = null
    var mAdapter: ChangeBatteryProgressAdapter? = null
    var orderNo: String? = null
    var plateNo: String? = null
    var orderStatus = 0


    companion object {
        /**
         *
         * @param batteryType 1:普通换电 3:紧急换电
         */
        fun openActivity(context: Context, batteryId: Long?, batteryType: Int) {
            var intent = Intent(context, ChangeBatteryProgressAct::class.java)
            intent.putExtra("batteryId", batteryId)
            intent.putExtra("batteryType", batteryType)
            context.startActivity(intent)
        }
    }

    private var batteryId: Long = 0
    private var batteryType: Int = 0

    override fun layoutId() = R.layout.activity_change_battery_progress

    override fun isVisibleTitleBar() = true

    override fun bindView(savedInstanceState: Bundle?) {

        batteryId = intent.getLongExtra("batteryId", 0)
        batteryType = intent.getIntExtra("batteryType", 0)

        mPresenter = ChangeBatteryProgressPresenter(this, this)
        mAdapter = ChangeBatteryProgressAdapter(this, mDatas, R.layout.adapter_order_progress)

        recyclerView.layoutManager = LinearLayoutManager(this)
        recyclerView.setAdapter(mAdapter)


        when (batteryType) {
            1 -> setTitle("免费换电")
            3 -> setTitle("紧急换电")
        }
        mPresenter?.getListProcess()
    }


    override fun setListData(data: ArrayList<ChangBatteryListBean.DataBean.ChangeVoBean>?) {
        data?.let {
            mDatas.clear()
            mDatas.addAll(it)
            mAdapter?.notifyDataSetChanged()
        }
    }

    override fun batteryId(): Long {
        return batteryId
    }

    override fun setPresenter(presenter: ChangeBatteryProgressContract.Presenter?) {
        this.setIPresenter(presenter)
    }
}