package com.baojia.mebike.feature.exclusive.shopping.changbattery

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.ChangBatteryListBean
import com.baojia.mebike.util.Toast

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.aboutexclusive
 * @author lycc1
 * @time 2018/12/24 21:10
 * @class describe
 * @class 中文描述
 */
class ChangeBatteryProgressPresenter(val mContext: Activity?, val mView: ChangeBatteryProgressContract.View) : BasePresenter(mContext), ChangeBatteryProgressContract.Presenter {

    var mModel: ChangeBatteryProgressModel? = null

    init {
        mView.setPresenter(this)
        mModel = ChangeBatteryProgressModel(mContext!!)
    }

    override fun getListProcess() {
        addDisposable(mModel?.getListProcess(mView.batteryId(),object : HttpCallback<ChangBatteryListBean>() {
            override fun onSucceed(data: ChangBatteryListBean?) {
                super.onSucceed(data)
                if (data?.data?.changeVo != null) {
                    mView.setListData(data.data.changeVo)
                }
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(mContext, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }))
    }

}