package com.baojia.mebike.feature.exclusive.shopping.orderprogress

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.shopping.ListProcessBean
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.BuyOrderProgressContract
import com.baojia.mebike.feature.exclusive.shopping.aboutexclusive.BuyOrderProgressPresenter
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.ToolBox
import kotlinx.android.synthetic.main.activity_buy_order_progress.*
import kotlinx.android.synthetic.main.include_bottom_common.*


/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.orderprogress
 * @author lycc1
 * @time 2018/12/25 16:50
 * @class describe
 * @class 中文描述  整车订购收货
 */
class BuyOrderProgressAct : BaseActivity(), BuyOrderProgressContract.View {

    private val mDatas = ArrayList<ListProcessBean.ProcessData.DataBean>()

    var mPresenter: BuyOrderProgressContract.Presenter? = null
    var mAdapter: BuyOrderProgressAdapter? = null
    var orderNo: String? = null
    var plateNo: String? = null
    var orderStatus = 0
    var goodsType = 0


    companion object {
        /**
         * @param  goodsType  1 整车订购（含电池）  2 整车订购（不含电池） 3 租车
         */
        fun openActivity(context: Context, orderNo: String, orderStatus: Int, goodsType: Int, plateNo: String) {
            var intent = Intent(context, BuyOrderProgressAct::class.java)
            intent.putExtra("orderNo", orderNo)
            intent.putExtra("orderStatus", orderStatus)
            intent.putExtra("goodsType", goodsType)
            intent.putExtra("plateNo", plateNo)
            context.startActivity(intent)
        }
    }

    override fun layoutId() = R.layout.activity_buy_order_progress

    override fun isVisibleTitleBar() = true

    override fun bindView(savedInstanceState: Bundle?) {
        intent?.let {
            orderNo = it.getStringExtra("orderNo")
            plateNo = it.getStringExtra("plateNo")
            orderStatus = it.getIntExtra("orderStatus", 0)
            goodsType = it.getIntExtra("goodsType", 0)
        }
        mPresenter = BuyOrderProgressPresenter(this, this)
        mAdapter = BuyOrderProgressAdapter(this, mDatas, R.layout.adapter_order_progress)

        recyclerView.layoutManager = LinearLayoutManager(this)
        recyclerView.setAdapter(mAdapter)

        bottomViewOkOnlyTv.text = ToolBox.getString(R.string.button_mine_hotline)
        bottomViewOkLeftTv.text = ToolBox.getString(R.string.button_hotline)
        bottomViewOkRightTv.text = ToolBox.getString(R.string.button_sure_receive)
        setViewClickDuration(bottomViewOkLeftTv, 1)
        setViewClickDuration(bottomViewOkRightTv, 1)
        setViewClickDuration(bottomViewOkOnlyTv, 1)

        setButtonVisable()
        mPresenter?.getListProcess(orderNo)
    }

    private fun setButtonVisable() {
        when (orderStatus) {
            5, 6 -> {
                bottomViewOkOnlyTv.visibility = View.VISIBLE
                bottomViewOkLeftTv.visibility = View.GONE
                bottomViewOkRightTv.visibility = View.GONE
            }
            2, 3, 4 -> {
                bottomViewOkOnlyTv.visibility = View.GONE
                bottomViewOkLeftTv.visibility = View.VISIBLE
                bottomViewOkRightTv.visibility = View.VISIBLE

            }
        }

    }

    override fun setLeftButtonOnClickListener() {
        JumpActivity.JumpToMainActivity(this)
    }

    override fun onBackPressed() {
        JumpActivity.JumpToMainActivity(this)
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            bottomViewOkLeftTv, bottomViewOkOnlyTv -> JumpActivity.JumpContactService(this)
            bottomViewOkRightTv ->mPresenter?.sureReceiveBike(orderNo, plateNo,goodsType);

        }
    }


    override fun setListData(data: ListProcessBean?) {
        data?.data?.let {
            mDatas.clear()

            it?.data?.let {
                if (it.isNotEmpty()) {
                    mDatas.addAll(it)
                }
            }
            mAdapter!!.notifyDataSetChanged()
        }
    }

    override fun setPresenter(presenter: BuyOrderProgressContract.Presenter?) {
    }
}