package com.baojia.mebike.feature.exclusive.shopping.orderprogress

import android.app.Activity
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.base.aboutbike.AboutBikeModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.CommData
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.exclusive.shapping.BuyOrderProgressResponse
import com.baojia.mebike.data.response.shopping.BikeConfigBean
import com.baojia.mebike.data.response.shopping.ListProcessBean
import com.baojia.mebike.data.response.shopping.ListProductBean
import com.baojia.mebike.data.response.shopping.MineOrderBean
import com.baojia.mebike.http.HttpUtils
import io.reactivex.disposables.Disposable
import java.util.HashMap

/**
 * @name mebikeRewrite
 * @classPackage com.baojia.mebike.feature.exclusive.shopping.aboutexclusive
 * @author lycc1
 * @time 2018/12/25 21:01
 * @class describe
 * @class 中文描述
 */
class BuyOrderProgressModel(activity: Activity) : AboutBikeModel(activity) {

    /**
     * 产品列表接口  专享商城
     */
    private val LIST_PROCESS = "/pmall/order/process/list"
    /**
     * 专属车 扫码确认  第二次确认
     */
    private val LIST_PMALL_SURE = "/pmall/bike/confirm/scan"

    fun getListProcess(orderNo: String, httpCallback: HttpCallback<ListProcessBean?>?): Disposable {
        val params = HashMap<String, Any>()
        params["orderNo"] = orderNo//产品ID
        return HttpUtils.postRequest(activity, LIST_PROCESS, params, true, httpCallback, ListProcessBean::class.java)
    }

    /**
     * 二次确认收车
     */
    fun sureReceiveBike(orderNo: String, plateNo: String?, httpCallback: HttpCallback<BuyOrderProgressResponse>): Disposable {
        val params = HashMap<String, Any>()
        params["orderNo"] = orderNo//产品ID
        params["plateNo"] = plateNo?:""//产品ID
        return HttpUtils.postRequest(activity, LIST_PMALL_SURE, params, true, httpCallback, BuyOrderProgressResponse::class.java)
    }

}