package com.baojia.mebike.feature.exclusive.shopping.selectBackAddress

import android.app.Activity
import com.amap.api.services.core.LatLonPoint
import com.amap.api.services.core.PoiItem
import com.amap.api.services.poisearch.PoiResult
import com.amap.api.services.poisearch.PoiSearch
import com.baojia.mebike.base.aboutbike.PersonAreaPresenter
import com.baojia.mebike.util.CollectionsWrapper
import com.baojia.mebike.util.Toast


class SelectBackAddressPresenter(val activity: Activity, val view: SelectBackAddressContract.View) : PersonAreaPresenter(activity, view)
        , SelectBackAddressContract.Presenter, PoiSearch.OnPoiSearchListener {


    private var query = PoiSearch.Query("", "地名地址信息", "")//商务住宅|公司企业|道路附属设施|地名地址信息|公共设施
    private var poiSearch: PoiSearch? = null


    override fun searchPoi() {
        view.searchLatLng()?.latLng ?: return
        query.let {
            it.pageNum = 0
            it.pageSize = 100
        }
        poiSearch = PoiSearch(activity, query)
        poiSearch?.setOnPoiSearchListener(this@SelectBackAddressPresenter)
        poiSearch?.bound = PoiSearch.SearchBound(LatLonPoint(view.searchLatLng()?.latLng!!.latitude, view.searchLatLng()?.latLng!!.longitude), 500)//
        poiSearch?.searchPOIAsyn()
    }

    override fun onPoiItemSearched(p0: PoiItem?, code: Int) {
        Toast.show(context, "$code")
    }

    override fun onPoiSearched(result: PoiResult?, code: Int) {
        context ?: return
        activity ?: return
        if (code == 1000) {
            if (result != null && result.query != null) {
                if (!CollectionsWrapper.isEmpty(result.pois)) {
                    view.setPoiData(result.pois)
                }
            }
        }
    }


}