package com.baojia.mebike.feature.join.JoinBuyActivity

import android.os.Bundle
import android.view.View
import com.baojia.mebike.R
import com.baojia.mebike.alipay.AliPayManager
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.PayListener
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.util.Toast
import com.baojia.mebike.util.WechatPayUtils
import kotlinx.android.synthetic.main.activity_join_pay.*
import kotlinx.android.synthetic.main.include_bottom_common.*
import kotlinx.android.synthetic.main.include_payment.*

class JoinBuyActivity : BaseActivity(), JoinBuyContract.View, PayListener {

    private var productId = 0
    private var year = 0
    private var joinMoney = ""

    override fun layoutId(): Int = R.layout.activity_join_pay
    override fun isVisibleTitleBar(): Boolean = true
    // 支付方式 1：微信支付 2：支付宝支付
    private var payMethod = 1
    val presenter = JoinBuyPresenter(this, this)
    override fun bindView(savedInstanceState: Bundle?) {

        intent?.let {
            productId = it.getIntExtra("productId",0)
            year = it.getIntExtra("year",0)
            joinMoney = it.getStringExtra("joinMoney")
        }

        joinPayTitleTv.text = "待支付$joinMoney 元"

        setPayMethod(1)

        setViewClickDuration(wechatPayLayout, 1)
        setViewClickDuration(aliPayLayout, 1)
        setViewClickDuration(bottomViewOkLeftTv, 1)
        setViewClickDuration(bottomViewOkRightTv, 1)

        presenter.getNamePhone()

    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            wechatPayLayout -> setPayMethod(1)
            aliPayLayout -> setPayMethod(2)
            bottomViewOkLeftTv -> {
                if (isNull()) {
                    return
                }
                presenter.joinCommit()
            }
            bottomViewOkRightTv -> {
                if (isNull()) {
                    return
                }
                presenter.joinPay()
            }
        }
    }

    override fun onResume() {
        super.onResume()
        presenter.checkOrderPayStatus()
    }

    fun isNull(): Boolean {
        if (joinPayNameEt.text.toString().isEmpty()) {
            Toast.show(this, "请输入您的姓名")
            return true
        }
        if (joinPayPhoneEt.text.toString().isEmpty()) {
            Toast.show(this, "请输入您的手机号")
            return true
        }
        return false
    }


    private fun setPayMethod(payWay: Int) {
        if (payWay == 1) {
            // 微信支付
            wechatSelectImageView.setImageResource(R.mipmap.selected_icon)
            aliSelectImageView.setImageResource(R.mipmap.unselected_icon)
        } else {
            // 支付宝支付
            aliSelectImageView.setImageResource(R.mipmap.selected_icon)
            wechatSelectImageView.setImageResource(R.mipmap.unselected_icon)
        }
        payMethod = payWay
    }

    override fun setPresenter(presenter: JoinBuyContract.Presenter?) {
    }


    override fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean) {
        if (dataBean.payChannelId == 1) {
            WechatPayUtils.wechatPay(this, dataBean.appid, dataBean.partnerid, dataBean.prepayid,
                    dataBean.wxpackage, dataBean.noncestr, dataBean.timestamp,
                    dataBean.sign)

        } else if (dataBean.payChannelId == 2) {
            AliPayManager(this)
                    .alipayV2(this, dataBean.orderInfo)
        }
    }

    override fun onSuccess() {
    }

    override fun onFailed(msg: String?) {
        Toast.show(this, msg)
    }

    override fun payMethod(): Int = payMethod

    override fun getProductId(): Int = productId

    override fun getYear(): Int = year

    override fun getName(): String = joinPayNameEt.text.toString()

    override fun getMobile(): String = joinPayPhoneEt.text.toString()

    override fun setPhone(phone: String) {
        joinPayPhoneEt.setText(phone)
    }

    override fun setName(name: String) {
        joinPayNameEt.setText(name)
    }

}