package com.baojia.mebike.feature.join.JoinBuyActivity

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.order.PayByOtherResponse

class JoinBuyContract  {

    interface View : IBaseView<Presenter> {
    
        /**
         * 支付成功回调
         * @param dataBean
         */
         fun orderPaySucceed(dataBean: PayByOtherResponse.DataBean)

        /**
         * 支付方式
         * @return
         */
         fun payMethod(): Int

        //产品id
        fun getProductId():Int

        //年份
        fun getYear():Int
        //姓名
        fun getName():String
        //手机号
        fun getMobile():String

        fun setName(name :String)
        fun setPhone(phone :String)


    }

    interface Presenter : IBasePresenter {
        /**
         * 支付
         */
         fun joinPay()

        /**
         * 查询订单支付状态
         */
         fun checkOrderPayStatus()

        /**
         * 加盟提交意向
         */
         fun joinCommit()
        //获取手机号姓名
         fun getNamePhone()
    }
}