package com.baojia.mebike.feature.join.JoinBuyActivity

import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.BaseResponse
import com.baojia.mebike.data.response.join.JoinCommitResponse
import com.baojia.mebike.data.response.join.PhoneRealNameResponse
import com.baojia.mebike.data.response.order.PayByOtherResponse
import com.baojia.mebike.util.JumpActivity

class JoinBuyPresenter(val activity: JoinBuyActivity,val view :JoinBuyContract.View) : BasePresenter(activity),JoinBuyContract.Presenter{

    val model = JoinBuyModel(activity)
    private var orderNo: String? = null

    override fun joinPay() {
        addDisposable(model.orderPay(view.getName(), view.getMobile(), view.getProductId(),view.getYear(),view.payMethod(), object : HttpCallback<PayByOtherResponse.DataBean>() {
            override fun onSucceed(data: PayByOtherResponse.DataBean) {
                super.onSucceed(data)
                view.orderPaySucceed(data)
                orderNo = data.orderNo
            }
        }))
    }

   override fun joinCommit() {
        addDisposable(model.joinCommit(view.getName(), view.getMobile(), view.getProductId(),view.getYear(), object : HttpCallback<JoinCommitResponse>() {
            override fun onSucceed(data: JoinCommitResponse?) {
                super.onSucceed(data)
                JumpActivity.JumpJoinSuccessActivity(activity,0)
                activity.finish()
            }
        }))
    }

    override fun checkOrderPayStatus() {
        orderNo?.let { model.checkOrderPayStatus(it,3, object : HttpCallback<BaseResponse?>() {
            override fun onSucceed(data: BaseResponse?) {
                super.onSucceed(data)
                data?.let {
                    JumpActivity.JumpJoinSuccessActivity(activity,1)
                    activity.finish()
                }
            }
        }) }

    }
    override fun getNamePhone() {
        model.getNamePhone( object : HttpCallback<PhoneRealNameResponse?>() {
            override fun onSucceed(data: PhoneRealNameResponse?) {
                super.onSucceed(data)
                data?.data?.mobile?.let {
                    view.setPhone(data.data.mobile)
                }
                data?.data?.realname?.let {
                    view.setName(data.data.realname)
                }
            }
        })
    }

}