package com.baojia.mebike.feature.join

import android.os.Bundle
import android.view.View
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinCommitResponse
import com.baojia.mebike.data.response.join.PhoneRealNameResponse
import com.baojia.mebike.feature.join.JoinBuyActivity.JoinBuyModel
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.activity_join_pay.*
import kotlinx.android.synthetic.main.activity_join_userinfo.*

class JoinUserInfoActivity : BaseActivity() {

    private var productId = 0
    private var year = 0
    var disposable: Disposable? = null

    override fun layoutId(): Int = R.layout.activity_join_userinfo
    override fun isVisibleTitleBar(): Boolean = true

    override fun bindView(savedInstanceState: Bundle?) {

        intent?.let {
            productId = it.getIntExtra("productId", 0)
            year = it.getIntExtra("year", 0)
        }

        setViewClickDuration(joinUserinfoOkTv, 1)

        disposable = JoinBuyModel(this).getNamePhone(object : HttpCallback<PhoneRealNameResponse?>() {
            override fun onSucceed(data: PhoneRealNameResponse?) {
                super.onSucceed(data)
                joinUserinfoNameEt.setText(data?.data?.realname)
                joinUserinfoPhoneEt.setText(data?.data?.mobile)
            }
        })
    }


    fun isNull(): Boolean {
        if (joinUserinfoNameEt.text.toString().isEmpty()) {
            Toast.show(this, "请输入您的姓名")
            return true
        }
        if (joinUserinfoPhoneEt.text.toString().isEmpty()) {
            Toast.show(this, "请输入您的手机号")
            return true
        }
        return false
    }


    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            joinUserinfoOkTv -> {
                if (isNull()) {
                    return
                }
                JoinBuyModel(this).joinCommit(joinUserinfoNameEt.text.toString(), joinUserinfoPhoneEt.text.toString(), productId, year, object : HttpCallback<JoinCommitResponse>() {
                    override fun onSucceed(data: JoinCommitResponse?) {
                        super.onSucceed(data)
                        data?.let {
                            JumpActivity.JumpJoinSuccessActivity(this@JoinUserInfoActivity, 0)
                            this@JoinUserInfoActivity.finish()
                        }
                    }

                    override fun onError(code: Int, message: String?) {
                        super.onError(code, message)
                        onFailed(-1, message)
                    }

                    override fun onFailed(code: Int, message: String?) {
                        super.onFailed(code, message)
                        Toast.show(this@JoinUserInfoActivity, message)
                    }
                })
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        disposable?.let {
            if (disposable!!.isDisposed) {
                disposable?.dispose()
                disposable = null

            }
        }
    }
}