package com.baojia.mebike.feature.join.details

import android.content.Context
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import androidx.core.content.ContextCompat
import androidx.fragment.app.FragmentManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.join.JoinOrderDetailsResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/14:4:53 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class JoinDetailsAdapter constructor(val fragmentManager: FragmentManager, val mContext: Context, val mData: List<JoinOrderDetailsResponse.DataBean.DescribeListBean>, val layoutId: Int) :
        BaseCommonAdapter<JoinOrderDetailsResponse.DataBean.DescribeListBean>(mContext, mData, layoutId) {


    override fun convert(holder: BaseViewHolder?, list: MutableList<JoinOrderDetailsResponse.DataBean.DescribeListBean>?, position: Int) {

        val mData = list?.get(position) ?: return
        holder?.setVisbility(R.id.lineImageView, false)
        holder?.setVisbility(R.id.bottomImageView, false)

        if (position != 0 && mData.lineFlag != list[position - 1].lineFlag) {
            // 显示分割线
            holder?.setVisbility(R.id.lineImageView, true)
            holder?.setVisbility(R.id.bottomImageView, true)
        }

        val tipsImageView = holder?.findView<ImageView>(R.id.tipsImageView)
        holder?.setVisbility(R.id.tipsImageView,false)
        if (mData.popFlag == 1) {
            holder?.setVisbility(R.id.tipsImageView,true)
        }
        holder?.setTextColor(R.id.contentTextView, ContextCompat.getColor(mContext, R.color.text_second_color))

        if (mData.colorFlag == 1) {
            holder?.setTextColor(R.id.contentTextView, ContextCompat.getColor(mContext, R.color.focus_text_color))
        }

        holder?.setText(R.id.titleTextView, mData.name)
        holder?.setText(R.id.contentTextView, mData.value)

        holder?.setOnClickListener(R.id.tipsImageView, View.OnClickListener {
            if (TextUtils.isEmpty(mData.popContent)) {
                return@OnClickListener
            }
            // 弹窗提示
            val dialog = JoinDetailsTisDialog()
            val bundle = Bundle()
            bundle.putString("title", mData.popTitle)
            bundle.putString("content", mData.popContent)
            if (!TextUtils.isEmpty(mData.colorValue)) {
                bundle.putString("colorValue", mData.colorValue)
            }
            dialog.arguments = bundle
            dialog.show(fragmentManager, "tipsDialog")
        })
    }
}