package com.baojia.mebike.feature.join.details

import android.os.Bundle
import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.join.JoinOrderDetailsResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/14:6:05 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
interface JoinDetailsContract {

    interface View : IBaseView<Presenter> {
        /**
         * 设置列表数据
         * @param mData
         */
        fun setRecyclerViewData(mData: ArrayList<JoinOrderDetailsResponse.DataBean.DescribeListBean>)

        /**
         * 订单编号
         */
        fun orderNo(): String

        /**
         * 显示进度
         * @param flag 0：不显示
         */
        fun showProgress(flag:Int)

        /**
         * 显示出售按钮
         */
        fun showBottom()

        fun hintBottom()

        fun setProgressInfo(processFlag: Int,
                            processRightDate: String?,
                            processRightStr: String?,
                            processLeftDate: String?,
                            processLeftStr: String?)

        /**
         * 设置金额
         */
        fun setTitleInfo(title :String?)

        /**
         * 设置状态信息
         */
        fun setStatusInfo(statusInfo:String?)

        /**
         * 设置状态信息颜色
         */
        fun setStatusInfoTextColor(colorRes:Int)

        /**
         * 放弃加盟显示的标题
         */
        fun setTitleByAbandon()
    }

    interface Presenter : IBasePresenter {
        /**
         * 获取详情
         */
        fun getDetails()

        fun sellBike()

        fun getSellDialogBundle() : Bundle?
    }
}