package com.baojia.mebike.feature.join.details

import android.text.Spannable
import android.text.SpannableString
import android.text.style.ForegroundColorSpan
import androidx.core.content.ContextCompat
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCompatDialogFragment
import com.baojia.mebike.data.CommData
import com.baojia.mebike.util.DensityUtil
import kotlinx.android.synthetic.main.dialog_join_details_tips.*

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/14:5:36 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class JoinDetailsTisDialog : BaseCompatDialogFragment() {
    override fun setContentView(): Int {
        return R.layout.dialog_join_details_tips
    }

    override fun bindView() {

        val title = bundle["title"]
        val content = bundle["content"]
        val colorValue = bundle["colorValue"]

        if (title != null) {
            titleTextView.text = title.toString()
        }

        if (colorValue == null) {
            if (content != null)
                contentTextView.text = content.toString()
        } else {
            if (content == null) return

            val split = content.toString().split(colorValue.toString())
            val spannableString = SpannableString(content.toString())
            if (split.size > 1) {
                spannableString.setSpan(ForegroundColorSpan(ContextCompat.getColor(context!!, R.color.focus_text_color)),
                        split[0].length, split[0].length + colorValue.toString().length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
            }
            contentTextView.text = spannableString
        }

        confirmButton.setOnClickListener {
            dismiss()
        }
    }

    override fun getWidth(): Int {
        return CommData.getScreen()[0] - DensityUtil.dip2px(activity, 50f)
    }
}