package com.baojia.mebike.feature.join.income

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.join.JoinIncomeDetailsResponse
import com.baojia.mebike.feature.join.myjoin.MyJoinActivity
import com.baojia.mebike.feature.join.record.JoinRecordListActivity
import com.baojia.mebike.util.DensityUtil
import com.baojia.mebike.util.JumpActivity
import com.baojia.mebike.util.ToolBox
import com.baojia.mebike.util.recyclerview.RecycleViewDivider
import kotlinx.android.synthetic.main.activity_join_income.*

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/14:10:15 AM
 * | @author house
 * | @class_describe 收益页面
 * +----------------------------------------------------------------------
 **/
class JoinIncomeActivity : BaseActivity(), JoinIncomeContract.View {



    private val mPresenter: JoinIncomePresenter = JoinIncomePresenter(this, this)
    private val mBikeData = arrayListOf<JoinIncomeDetailsResponse.DataBean.CarNumBean>()
    private var myJoinAdapter: MyJoinBikeAdapter? = null

    override fun layoutId(): Int {
        return R.layout.activity_join_income
    }

    override fun bindView(savedInstanceState: Bundle?) {

//        setToolBar();

        setAdapter()
        setClickListener()

    }

    private fun setClickListener() {
        setViewClickDuration(withdrawRecordLayout,1)
        setViewClickDuration(incomeRecordLayout,1)
        setViewClickDuration(myJoinLayout,1)
        setViewClickDuration(withdrawDepositButton,1)
        setViewClickDuration(joinButton,1)
        setViewClickDuration(backButton,1)
    }

    override fun onResume() {
        super.onResume()
        mPresenter.getDetails()
    }

//    private fun setToolBar() {
//
//        setSupportActionBar(incomeToolbar)
//        incomeToolbar.title = ""
//
//        supportActionBar?.setHomeButtonEnabled(true)
//        supportActionBar?.setDisplayHomeAsUpEnabled(true)
//        supportActionBar?.setDisplayShowTitleEnabled(false)
//
//        incomeToolbar.setNavigationIcon(R.mipmap.back_icon)
//
//        incomeToolbar.setNavigationOnClickListener {
//            finish()
//        }
//
//        collapsingToolbarLayout.title = ""
//    }

    private fun setAdapter() {
        myJoinAdapter = MyJoinBikeAdapter(this,mBikeData,R.layout.item_my_join)
        myJoinRecyclerView.layoutManager = LinearLayoutManager(this)
        myJoinRecyclerView.adapter = myJoinAdapter
        myJoinRecyclerView.addItemDecoration(RecycleViewDivider(this, RecyclerView.VERTICAL, DensityUtil.dip2px(this, 10f), R.color.white_color))
    }


    override fun setAmount(amount: String?) {
        canWithdrawAmountTextView.text = amount
    }

    override fun setDrawAmount(amount: String?) {
        withdrawAmountTextView.text = amount + "元"
    }

    override fun setTotalAmount(totalAmount: Number?) {
        incomeAmountTextView.text = "${ToolBox.getTwoDecimal(totalAmount as Double)}元"
    }

    override fun setYesterdayAmount(amount: String?) {
        yesterdayIncomeAmountTextView.text = amount + "元"
    }

    override fun haveIncome() {
        canWithdrawAmountTextView.visibility = View.VISIBLE
        canWithdrawAmountIntroduceTextView.visibility = View.VISIBLE
        noDataTextView.visibility = View.GONE
    }

    override fun noIncome() {
        canWithdrawAmountTextView.visibility = View.GONE
        canWithdrawAmountIntroduceTextView.visibility = View.GONE
        noDataTextView.visibility = View.VISIBLE
    }

    override fun setBikeData(mData: ArrayList<JoinIncomeDetailsResponse.DataBean.CarNumBean>?) {
        mBikeData.clear()
        if (mData != null) {
            mBikeData.addAll(mData)
        }
        myJoinAdapter?.notifyDataSetChanged()
    }

    override fun setPresenter(presenter: JoinIncomeContract.Presenter?) {
        this.setIPresenter(presenter)
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view?.id) {
            R.id.withdrawRecordLayout -> {
                // 提现记录
                JoinRecordListActivity.start(this, 1)
            }
            R.id.incomeRecordLayout -> {
                // 分成记录
                JoinRecordListActivity.start(this)
            }
            R.id.myJoinLayout -> {
                // 我的加盟列表
                MyJoinActivity.start(this)
            }
            R.id.withdrawDepositButton -> {
                // 提现
                JumpActivity.JumpAdoptWithdrawActivity(this,1)
            }
            R.id.joinButton -> {
                // 加盟
                mPresenter?.startJoinHome()
            }
            R.id.backButton -> finish()
        }
    }


    companion object {
        @JvmStatic
        fun start(activity: Activity) {
            val intent = Intent()
            intent.setClass(activity, JoinIncomeActivity::class.java)
            activity.startActivity(intent)
        }
    }
}