package com.baojia.mebike.feature.join.income

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.join.JoinIncomeDetailsResponse

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/15:12:48 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
interface JoinIncomeContract {

    interface View : IBaseView<Presenter> {
        /**
         * 设置账户余额
         */
        fun setAmount(amount: String?)

        /**
         * 设置已提现金额
         */
        fun setDrawAmount(amount: String?)

        /**
         * 设置总收益金额
         */
        fun setTotalAmount(totalAmount: Number?)

        /**
         * 设置昨日收益金额
         */
        fun setYesterdayAmount(amount: String?)

        fun setBikeData(mData: ArrayList<JoinIncomeDetailsResponse.DataBean.CarNumBean>?)

        fun noIncome()

        fun haveIncome()
    }

    interface Presenter : IBasePresenter {
        /**
         * 收益详情
         */
        fun getDetails()

        /**
         * 跳转加盟首页
         */
        fun startJoinHome()
    }

}