package com.baojia.mebike.feature.join.income

import android.app.Activity
import com.baojia.mebike.base.BaseModel
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinIncomeDetailsResponse
import com.baojia.mebike.http.HttpUtils
import com.baojia.mebike.util.Toast
import io.reactivex.disposables.Disposable

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/15:12:52 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class JoinIncomeModel constructor(val mContext: Activity) : BaseModel(mContext) {

    private final val INCOME_DETAILS_URL: String = "/bike/user/join/detail"

    fun getDetails(httpCallback: HttpCallback<JoinIncomeDetailsResponse.DataBean>?): Disposable {
        return HttpUtils.postRequest(mContext, INCOME_DETAILS_URL, null, object : HttpCallback<JoinIncomeDetailsResponse>() {
            override fun onSucceed(data: JoinIncomeDetailsResponse?) {
                super.onSucceed(data)
                if (data?.data == null) {
                    return
                }

                httpCallback?.onSucceed(data.data)

            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                Toast.show(mContext, message)
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                onFailed(code, message)
            }
        }, JoinIncomeDetailsResponse::class.java)
    }
}