package com.baojia.mebike.feature.join.income

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinIncomeDetailsResponse
import com.baojia.mebike.util.JumpActivity

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/15:1:12 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class JoinIncomePresenter constructor(val mContext: Activity, val mView: JoinIncomeContract.View?) : BasePresenter(mContext),JoinIncomeContract.Presenter {

    private var joinWebTitle:String? = null
    private var joinWebUrl:String? = null



    private var incomeModel : JoinIncomeModel? = null

    init {
        mView?.setPresenter(this)
        incomeModel = JoinIncomeModel(mContext)
    }


    override fun getDetails() {
        incomeModel?.getDetails(object : HttpCallback<JoinIncomeDetailsResponse.DataBean>(){
            override fun onSucceed(data: JoinIncomeDetailsResponse.DataBean?) {
                super.onSucceed(data)

                mView?.setAmount(data?.amountStr)
                mView?.setBikeData(data?.carNum)
                mView?.setDrawAmount(data?.drawAmountStr)
                mView?.setTotalAmount(data?.totalAmount)
                mView?.setYesterdayAmount(data?.yesterdayProfitStr)

                if (data?.totalAmount == 0.00) {
                    mView?.noIncome()
                } else {
                    mView?.haveIncome()
                }
                joinWebUrl = data?.joinUrl
                joinWebTitle = data?.joinTitle
            }
        })
    }

    override fun startJoinHome() {
        JumpActivity.JumpWebView(mContext, joinWebTitle, joinWebUrl)
    }
}