package com.baojia.mebike.feature.join.myjoin

import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.join.MyJoinResponse
import com.baojia.mebike.util.ToolBox

class MyJoinAdapter(activity: MyJoinActivity, mDatas: ArrayList<MyJoinResponse.DataBean.OrderBean>, layoutId: Int)
    : BaseCommonAdapter<MyJoinResponse.DataBean.OrderBean>(activity, mDatas, layoutId) {


    override fun convert(holder: BaseViewHolder?, list: MutableList<MyJoinResponse.DataBean.OrderBean>?, position: Int) {
        list ?: return
        list[position] ?: return
        val item = list[position]
        holder?.setText(R.id.myJoinItemTitleTv, item.amount)
        holder?.setText(R.id.myJoinItemTimeTv, item.joinTime)
        holder?.setImageUrl(R.id.myJoinItemBikeIv,item.img,R.drawable.pic_bike_myjoin)
        holder?.setBackgroundRes(R.id.myJoinItemBgIv,R.drawable.radius_white)

        //订单状态0未支付未审核，1已支付未审核，2运营中，3出售中，4已出售，5已放弃  6 已支付未审核已放弃
        when (item.orderStatus) {
            0 -> {
                holder?.setText(R.id.myJoinItemStateTv, "待支付")
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.focus_text_color))
            }
            1 -> {
                holder?.setText(R.id.myJoinItemStateTv, "生产中")
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.second_other_color))
            }
            2 -> {
                holder?.setText(R.id.myJoinItemStateTv, "出租中")
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.color_2c9d23))
            }
            3 -> {
                holder?.setText(R.id.myJoinItemStateTv, "出售中")
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.focus_text_color))
            }
            4 -> {
                holder?.setText(R.id.myJoinItemStateTv, "已出售")
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.text_second_color))
            }
            5 -> {
                holder?.setText(R.id.myJoinItemStateTv, "已放弃")
                holder?.setBackgroundRes(R.id.myJoinItemBgIv,R.drawable.radius_grey)
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.text_second_color))
            }
            6 -> {
                holder?.setText(R.id.myJoinItemStateTv, "已放弃")
                holder?.setBackgroundRes(R.id.myJoinItemBgIv,R.drawable.radius_grey)
                holder?.setTextColor(R.id.myJoinItemStateTv,ToolBox.getColor(R.color.text_second_color))
            }
        }
    }


}
