package com.baojia.mebike.feature.join.myjoin

import com.baojia.mebike.base.IBasePresenter
import com.baojia.mebike.base.IBaseView
import com.baojia.mebike.data.response.join.MyJoinResponse

class MyJoinContract {

     interface View : IBaseView<Presenter> {

        /**
         * 刷新列表成功
         */
        fun refreshDataSucceed()

        /**
         * 刷新列表失败
         */
        fun refreshDataFailed(result: String)

        /**
         * 上拉加载
         */
        fun loadMoreDataSucceed()

        /**
         * 上拉加载
         */
        fun loadMoreDataFailed(result: String)


        /**
         * 显示没有数据的页面
         */
        fun showNoDataPage()

        /**
         * 显示没有网络的页面
         */
        fun showNoNetPage()

        /**
         * 显示没有网络的页面
         */
        fun showErrorPage()

        /**
         * 显示没有数据的页面
         */
        fun hideAllPage()

        /**
         * 设置数据
         *
         * @param mDatas    数据
         * @param isRefresh true：刷新  false：加载更多
         */
        fun setMyJoinDatas(mDatas: List<MyJoinResponse.DataBean.OrderBean>, isRefresh: Boolean)


    }


     interface Presenter : IBasePresenter {

        /**
         * 获取列表信息
         */
        fun getMyJoinlList(isRefresh: Boolean)
    }
}