package com.baojia.mebike.feature.join.myjoin

import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.MyJoinResponse

class MyJoinPresenter(val activity: MyJoinActivity, val view : MyJoinContract.View) : BasePresenter(activity) ,MyJoinContract.Presenter {

    private val model : MyJoinModel = MyJoinModel(activity)
    var mPageIndex = 1

    override fun getMyJoinlList(isRefresh: Boolean) {
        if (isRefresh) {
            mPageIndex = 1
        } else {
            mPageIndex += 1
        }
        addDisposable(model.getJoinPlantData(mPageIndex, object : HttpCallback<MyJoinResponse>() {
            override fun onSucceed(data: MyJoinResponse?) {
                super.onSucceed(data)
                view.hideAllPage()
                if (isRefresh) {
                    view.refreshDataSucceed()
                } else {
                    view.loadMoreDataSucceed()
                }
                if (data == null || data.data == null || data.data.order.isEmpty() ){
                    view.showNoDataPage()
                    return
                }
                view.setMyJoinDatas(data.data.order,isRefresh)
            }

            override fun onFailed(code: Int, message: String) {
                super.onFailed(code, message)
                view.hideAllPage()
                view.showNoDataPage()
                if (isRefresh) {
                    view.refreshDataFailed("")
                } else {
                    view.loadMoreDataFailed("")
                }
            }

            override fun onError(code: Int, message: String) {
                super.onFailed(-1, message)
            }

            override fun onErrorByNoNetwork() {
                super.onErrorByNoNetwork()
                view.hideAllPage()
                view.showNoNetPage()
                if (isRefresh) {
                    view.refreshDataFailed("")
                } else {
                    view.loadMoreDataFailed("")
                }
            }
        }))
    }

}