package com.baojia.mebike.feature.join.plant

import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseActivity
import com.baojia.mebike.data.response.ItemStringResponse
import com.baojia.mebike.data.response.join.JoinPlantListResponse
import com.baojia.mebike.util.JumpActivity
import kotlinx.android.synthetic.main.activity_join_plant.*
import kotlinx.android.synthetic.main.include_bottom_common.*

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/13:6:59 PM
 * | @author house
 * | @class_describe 加盟列表页面
 * +----------------------------------------------------------------------
 **/
class JoinPlantActivity : BaseActivity(), JoinPlantContract.View {

    private val presenter: JoinPlantPresenter? = JoinPlantPresenter(this, this)
    //车辆列表数据
    private var mData = ArrayList<JoinPlantListResponse.DataBean.ProductBean>()
    private var mDataOther = ArrayList<JoinPlantListResponse.DataBean.ProductBean>()
    private var h5title: String? = ""
    private var h5url: String? = ""
    private var itemData: JoinPlantListResponse.DataBean.ProductBean? = null
    private var year: Int? = 1

    //几年的列表数据
    private var dataList = arrayListOf<ItemStringResponse>(ItemStringResponse("一年", true),
            ItemStringResponse("二年", false), ItemStringResponse("三年", false))

    //几年选择适配器
    private val joinPlantDataAdapter: JoinPlantDataAdapter? = JoinPlantDataAdapter(this, dataList, R.layout.item_join_date)
    //车辆选择适配器
    private val joinPlantAdapter: JoinPlantAdapter? = JoinPlantAdapter(this, mData, R.layout.item_join_plant)

    override fun setPresenter(presenter: JoinPlantContract.Presenter?) {
    }

    override fun setJoinPlantData(data: JoinPlantListResponse.DataBean) {
        h5title = data.h5Title
        h5url = data.h5Url
        mData.clear();
        mDataOther.clear();
        if (data.product.size >= 3) {
            mData.add(data.product[0])
            mData.add(data.product[1])
            mData.add(data.product[2])
            for (index in data.product.indices) {
                if (index > 2) {
                    mDataOther.add(data.product[index])
                }
            }
        } else {
            for (item in data.product) {
                mData.addAll(data.product)
            }
            moreButton.visibility = View.GONE
        }
        mData[0].isClick = true
        itemData = mData[0]
        showOneButton(mData[0].internetPay)
        joinPlantAdapter?.notifyDataSetChanged()
        moreButton.visibility = View.VISIBLE
    }

    override fun isVisibleTitleBar(): Boolean = true

    override fun layoutId(): Int = R.layout.activity_join_plant

    override fun bindView(savedInstanceState: Bundle?) {

        bottomViewOkRightTv.text = "确认加盟"

        dateRecyclerView.layoutManager = GridLayoutManager(this, 3)
        dateRecyclerView.adapter = joinPlantDataAdapter

        plantRecyclerView.layoutManager = LinearLayoutManager(this)
        plantRecyclerView.adapter = joinPlantAdapter

        setViewClickDuration(bottomViewOkLeftTv, 1)
        setViewClickDuration(bottomViewOkRightTv, 1)
        setViewClickDuration(bottomViewOkOnlyTv, 1)
        setViewClickDuration(moreButton, 1)


        this.joinPlantDataAdapter?.setOnItemClickListner { _, position ->
            run {
                for (item in dataList) {
                    item.isClick = false
                }
                dataList[position].isClick = true
                year = position + 1
                return@run this.joinPlantDataAdapter?.notifyDataSetChanged();
            }
        }

        joinPlantAdapter?.setOnItemClickListner { _, position ->
            run {
                //底部按钮处理
                showOneButton(mData[position].internetPay)
                //背景框处理
                for (item in mData) {
                    item.isClick = false
                }
                mData[position].isClick = true
                itemData = mData[position]
                return@run this.joinPlantAdapter?.notifyDataSetChanged()
            }
        }

        presenter?.getJoinPlantData()

    }

    /**
     * 0 一个   1 两个
     */
    private fun showOneButton(yes: Int) {
        if (yes == 0) {
            bottomViewOkLeftTv.visibility = View.GONE
            bottomViewOkRightTv.visibility = View.GONE
            bottomViewOkOnlyTv.visibility = View.VISIBLE
        } else {
            bottomViewOkLeftTv.visibility = View.VISIBLE
            bottomViewOkRightTv.visibility = View.VISIBLE
            bottomViewOkOnlyTv.visibility = View.GONE
        }
    }

    override fun setViewClick(view: View?) {
        super.setViewClick(view)
        when (view) {
            bottomViewOkLeftTv,
            bottomViewOkOnlyTv -> {
                JumpActivity.JumpWebView(this, h5title, getJumpUrl(0))
            }
            bottomViewOkRightTv -> JumpActivity.JumpWebView(this, h5title, getJumpUrl(null))
            moreButton -> getMoreData()
        }
    }

    /**
     * internetPay 0 提交意向   null 默认
     */
    private fun getJumpUrl(internetPay: Int?): String {
        var h5urlJump = ""
        var internetPayH5 = itemData?.internetPay
        internetPay?.let {
            internetPayH5 = it
        }
        h5url?.let {
            h5urlJump = if (it.contains("?")) {
                "$it&ID=${itemData?.id}&carNumbuer=${itemData?.carNumbuer}&porfit=${itemData?.porfit}&internetPay=$internetPayH5&joinMoney=${itemData?.joinMoney}&year=$year"
            } else {
                "$it?ID=${itemData?.id}&carNumbuer=${itemData?.carNumbuer}&porfit=${itemData?.porfit}&internetPay=$internetPayH5&joinMoney=${itemData?.joinMoney}&year=$year"
            }
        }
        return h5urlJump
    }

    /**
     * 获取更多
     */
    private fun getMoreData() {
        moreButton.visibility = View.GONE
        if (mDataOther.isEmpty()) return
        mData.addAll(mDataOther)
        joinPlantAdapter?.notifyDataSetChanged()
    }


}