package com.baojia.mebike.feature.join.plant

import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinPlantListResponse
import com.baojia.mebike.util.Toast

class JoinPlantPresenter(val activity: JoinPlantActivity, val view: JoinPlantContract.View?) : BasePresenter(activity), JoinPlantContract.Presenter {

   private val model: JoinPlantModel = JoinPlantModel(activity)

    override fun getJoinPlantData() {

        addDisposable(model.getJoinPlantData(object : HttpCallback<JoinPlantListResponse>() {
            override fun onSucceed(data: JoinPlantListResponse?) {
                super.onSucceed(data)
                data ?: return
                view?.setJoinPlantData(data.data)
            }

            override fun onFailed(code: Int, message: String) {
                super.onFailed(code, message)
                Toast.show(activity, message)
            }

            override fun onError(code: Int, message: String) {
                onFailed(-1, message)
            }
        }))

    }
}