package com.baojia.mebike.feature.join.record

import android.content.Context
import androidx.core.content.ContextCompat
import com.baojia.mebike.R
import com.baojia.mebike.base.BaseCommonAdapter
import com.baojia.mebike.base.BaseViewHolder
import com.baojia.mebike.data.response.join.JoinRecordResponse
import com.baojia.mebike.util.ToolBox

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/17:3:46 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class JoinRecordListAdapter(private val context: Context,
                            private val list: ArrayList<JoinRecordResponse.DataBean>,
                            private val layoutId: Int) : BaseCommonAdapter<JoinRecordResponse.DataBean>(context, list, layoutId) {
    override fun convert(holder: BaseViewHolder?, list: MutableList<JoinRecordResponse.DataBean>?, position: Int) {
        list ?: return
        list[position]?.let {
            holder?.setText(R.id.earningDetailItemTitleTv, it.title)
            holder?.setTextColor(R.id.earningDetailItemDesTv, ContextCompat.getColor(context, R.color.focus_text_color))
            if (it.amountStr >= 0) {
                holder?.setText(R.id.earningDetailItemDesTv, "+${ToolBox.getTwoDecimal(it.amountStr)}")
                holder?.setTextColor(R.id.earningDetailItemDesTv, ContextCompat.getColor(context, R.color.color_26C319))
            } else {
                holder?.setText(R.id.earningDetailItemDesTv, "-${ToolBox.getTwoDecimal(it.amountStr * -1)}")
            }
            holder?.setText(R.id.earningDetailItemTimeTv, it.time)
            holder?.setText(R.id.earningDetailItemAllTv, "${ToolBox.getTwoDecimal(it.currentAmount)}")

            holder?.setVisbility(R.id.failImageView, false)
            holder?.setBackgroundRes(R.id.earningDetailItemMainbgIv, R.color.white_color)

            if (it.auditingStatus == 1) {
                holder?.setVisbility(R.id.failImageView, true)
                holder?.setBackgroundRes(R.id.earningDetailItemMainbgIv, R.color.title_background_color)
            }

            holder?.itemView?.setOnClickListener {
                onItemChildViewClickListner?.onItemChildViewClick(it,position)
            }

        }
    }
}