package com.baojia.mebike.feature.join.record

import android.app.Activity
import com.baojia.mebike.base.BasePresenter
import com.baojia.mebike.callback.HttpCallback
import com.baojia.mebike.data.response.join.JoinRecordResponse
import com.baojia.mebike.util.CollectionsWrapper

/**
 * +----------------------------------------------------------------------
 * | @time 2018/12/17:7:43 PM
 * | @author house
 * | @class_describe
 * +----------------------------------------------------------------------
 **/
class JoinRecordPresenter constructor(val mContext: Activity, var mView: JoinRecordContract.View) : BasePresenter(mContext),
        JoinRecordContract.Presenter {

    private var recordModel:JoinRecordModel? = null
    private var mPageIndex: Int = 1

    init {
        mView.setPresenter(this)
        recordModel = JoinRecordModel(mContext)
    }

    override fun getRecordData(isRefresh:Boolean) {
        if (isRefresh) {
            mPageIndex = 1
        } else {
            mPageIndex += 1
        }
        recordModel?.getRecord(mView.getRecordType(),mPageIndex,object :HttpCallback<ArrayList<JoinRecordResponse.DataBean>?>(){
            override fun onSucceed(data: ArrayList<JoinRecordResponse.DataBean>?) {
                super.onSucceed(data)
                if (isRefresh) {
                    mView.refreshDataSucceed()
                    if (CollectionsWrapper.isEmpty(data)) {
                        mView.hideAllPage()
                        mView.showNoDataPage()
                        mView.loadMoreDataFailed("")
                        return
                    }
                } else {
                    mView.loadMoreDataSucceed()
                }

                mView.setRecordData(data,isRefresh)
            }

            override fun onFailed(code: Int, message: String?) {
                super.onFailed(code, message)
                mView.hideAllPage()
                mView.showNoDataPage()
                if (isRefresh) {
                    mView.refreshDataFailed(message)
                } else {
                    mView.loadMoreDataFailed(message)
                }
            }

            override fun onError(code: Int, message: String?) {
                super.onError(code, message)
                mView.hideAllPage()
                mView.showNoDataPage()
                if (isRefresh) {
                    mView.refreshDataFailed(message)
                } else {
                    mView.loadMoreDataFailed(message)
                }
            }
        })
    }
}